Package: broadSeq
Title: broadSeq : for streamlined exploration of RNA-seq data
Version: 1.7.0
Authors@R: 
    person("Rishi", "Das Roy", , "rishi.dasroy@gmail.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-3276-7279"))
Description: This package helps user to do easily RNA-seq data analysis with multiple 
    methods (usually which needs many different input formats). Here the user will 
    provid the expression data as a SummarizedExperiment object and will get results 
    from different methods. It will help user to quickly evaluate different methods. 
License: MIT + file LICENSE
URL: https://github.com/dasroy/broadSeq
BugReports: https://github.com/dasroy/broadSeq/issues
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
biocViews: GeneExpression, DifferentialExpression, RNASeq,
        Transcriptomics, Sequencing, Coverage, GeneSetEnrichment, GO
Suggests: knitr, limma (>= 3.54.0), rmarkdown, stats (>= 4.2.2), samr
Depends: dplyr, ggpubr, SummarizedExperiment
Imports: BiocStyle, DELocal, EBSeq (>= 1.38.0), DESeq2 (>= 1.38.2),
        NOISeq, forcats (>= 1.0.0), genefilter, ggplot2, ggplotify,
        plyr, clusterProfiler (>= 4.8.2), pheatmap, sechm (>= 1.6.0),
        stringr, purrr (>= 0.3.5), edgeR (>= 3.40.1)
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/broadSeq
git_branch: devel
git_last_commit: 4cc0a21
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:37:45 UTC; biocbuild
Author: Rishi Das Roy [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3276-7279>)
Maintainer: Rishi Das Roy <rishi.dasroy@gmail.com>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# broadSeq

<!-- badges: start -->
<!-- badges: end -->

The goal of broadSeq is to do easily RNA-seq data analysis with multiple
methods (usually which needs many different input formats). Here the
user will provide the expression data as a
*[SummarizedExperiment](https://bioconductor.org/packages/3.17/SummarizedExperiment)*
object and will get results from different methods. This function
oriented package will give user freedom to develop customized and
reproducible workflow. Additionally, it will also help to quickly
evaluate different methods easily.

![](man/figures/README-unnamed-chunk-2-1.png)

##### This is under active development. Please report if you find any bug.

## Installation

``` r
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("broadSeq")
```

You can install the development version of broadSeq from
[GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("dasroy/broadSeq")
```

For package documentation

``` r
devtools::install_github("dasroy/broadSeq", build_vignettes = TRUE)
browseVignettes(package = "broadSeq")
```

---
output: github_document
link-citations: TRUE
editor_options: 
  markdown: 
    wrap: 72
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, setup,include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.path = "man/figures/README-",
  out.width = "100%"
)
library(dplyr)
require(ggplot2)
```

# broadSeq 

<!-- badges: start -->

<!-- badges: end -->

```{r echo=FALSE,message=FALSE,warning=FALSE,eval=FALSE}
# library(emojifont)
io_flow <- read.csv(system.file("extdata", "Method_io.csv", package = "broadSeq"))

df <- io_flow %>% 
    ggsankey::make_long(Input, Method, Output)


pl <- ggplot(df, aes(x = x,                        
                     next_x = next_x,                                     
                     node = node,
                     next_node = next_node,        
                     fill = factor(node),
                     label = node))+scale_x_discrete(position = "top") 

pl <- pl + ggsankey::geom_sankey(flow.alpha = 0.5,          #This Creates the transparency of your node 
                      node.color = "black",     # This is your node color        
                      show.legend = FALSE)        # This determines if you want your legend to show

pl <- pl + ggsankey::geom_sankey_label(show.legend = FALSE,
                             color = "black", 
                             fill = "white") # This specifies the Label format for each node 

io_p <- pl+labs(x="")+ ggsankey::theme_sankey(base_size = 25)
io_p
```

The goal of broadSeq is to do easily RNA-seq data analysis with multiple
methods (usually which needs many different input formats). Here the
user will provide the expression data as a `r BiocStyle::Biocpkg("SummarizedExperiment")` object
and will get results from different methods. This function oriented package will
give user freedom to develop customized and reproducible workflow. Additionally,
it will also help to quickly evaluate different methods easily.

```{r  echo=FALSE,message=FALSE,warning=FALSE,eval=FALSE}
io_flow <- read.csv(system.file("extdata", "broadSeq_pipeline.csv", package = "broadSeq"))

df <- io_flow %>% 
    ggsankey::make_long(Input,  Function, Method, Output,ggpubr)
df$node <- factor(df$node, levels = unique(c( io_flow$Function, io_flow$Method,
                                           io_flow$Output, io_flow$ggpubr)))

pl <- ggplot(df, aes(x = x,                        
                     next_x = next_x,                                     
                     node = node,
                     next_node = next_node,        
                     fill = factor(node),
                     label = node))+scale_x_discrete(position = "top") 

pl <- pl + ggsankey::geom_sankey(flow.alpha = 0.5,  #This Creates the transparency of your node 
                      show.legend = FALSE)      # This determines if you want your legend to show

pl <- pl + ggsankey::geom_sankey_label(show.legend = FALSE,
                             color = "black", size =3 ,
                             fill = "white") # This specifies the Label format for each node 

pl+labs(x="")+ ggsankey::theme_sankey(base_size = 20)
```

![](man/figures/README-unnamed-chunk-2-1.png)
  
##### This is under active development. Please report if you find any bug.

## Installation

```{r eval=FALSE}
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("broadSeq")
```

You can install the development version of broadSeq from
[GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("dasroy/broadSeq")
```

For package documentation 
``` r
devtools::install_github("dasroy/broadSeq", build_vignettes = TRUE)
browseVignettes(package = "broadSeq")
```

checkNameSpace <- function(packageName) {
    if (!requireNamespace(packageName, quietly = TRUE)) {
        stop(
            paste("Package \"",  packageName , "\" must be installed to use this function.", sep = ""),
            call. = FALSE
        )
    }else{
        return(TRUE)
    }
}

#' Useful to visualize distribution of assay values for each sample. Plots 'boxplot'
#' of any assay for each sample. Aesthetic can be added from colData.
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param assayName One of the values from SummarizedExperiment::assayNames(se)
#' @param ... other arguments to be passed to ggpubr::\code{\link{ggboxplot}}
#'
#' @return ggplot object
#' @export
#' @importFrom ggpubr ggboxplot rotate_x_text
#' @importFrom sechm meltSE
#' @importFrom SummarizedExperiment assayNames
#' @examples
#' se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))
#'
#' sampleAssay_plot(se, assayName = "counts",
#' fill="stage", # stage is a column name of colData(se)
#' yscale="log2")
#'
#' se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
#'
#' sampleAssay_plot(se, assayName = "logCPM", fill="stage")
sampleAssay_plot <- function(se, assayName = "counts",...){
    checkNameSpace("sechm")
    stopifnot("assayName not found"=(assayName %in% SummarizedExperiment::assayNames(se)))

    d <- sechm::meltSE(se,features=rownames(se), assayName = assayName )
    d %>% ggpubr::ggboxplot(y = assayName, x= "sample", ...)+rotate_x_text()
}

#' Expression of multiple genes/features from a single assay as boxplot (or added dotplot)
#'
#'
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param features a character vector of rownames or named list of character vectors
#'  where name is one of the colnames of rowdata.
#' @param assayName One of the values from SummarizedExperiment::assayNames(se);
#' default is "counts" assay
#' @param facet.by must be one of the column names of rowData(se). default
#' "feature" which is equivalent to rownames of rowData
#' @param x a column name of colData which will be used in x-axis
#' @param ... other arguments to be passed to ggpubr::\code{\link{ggboxplot}}
#'
#' @return ggplot object
#' @export
#' @importFrom ggpubr ggboxplot facet
#' @importFrom dplyr filter
#' @examples
#' se <- readRDS(system.file("extdata", "rat_vole_mouseSE_salmon.rds",
#'     package = "broadSeq"))
#' # The normalized values are added with the assay name "logCPM"
#' se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
#'
#' broadSeq::genes_plot(se,
#'                      features = list(mouse_gene_id = c("ENSMUSG00000022510" ,
#'                                                         "ENSMUSG00000027985")),
#'                      facet.by = "symbol", # column of rowData
#'                      x = "stage",  fill="stage")
#'
#' broadSeq::genes_plot(se,
#'                      features = list(symbol=c("Shh","Edar") ),
#'                      facet.by = "symbol", # column of rowData
#'                      x = "stage",  fill="stage")
#'
#'broadSeq::assay_plot(se, feature = c("Shh"),
#'                     assays =  c("counts","logCPM"),
#'                     x = "stage", fill="stage", add="dotplot", palette = "npg")
genes_plot <- function(se, features, assayName = "counts", facet.by = "feature",
                       x, ...){
    checkNameSpace("sechm")
    stopifnot("assayName not found"=(assayName %in% SummarizedExperiment::assayNames(se)))
    stopifnot("features is not character or list"=(is.character(features) | is.list(features)))
    stopifnot("facet.by is not a column name of rowData"=(facet.by %in% colnames(rowData(se))))

    if(is.list(features)){
        stopifnot("list length must be 1"=(length(features)==1))
        stopifnot("name of list must be one of colnames of rowData(se)"=(
            all(names(features) %in% colnames(rowData(se)) ) ) )
        features <- as.data.frame( rowData(se)) %>%
            filter(get(names(features)) %in%  features[[1]]) %>% rownames()
    }

    d <- sechm::meltSE(se,features )
    d %>% ggboxplot(y=assayName, x=x, ... ) %>%
        facet(facet.by , scale="fixed")
}

#' Boxplot of a single gene/feature from multiple assays
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param feature a character vector of rownames or named list of character vectors
#'  where name is one of the column of rowdata.
#' @param assayNames  names from SummarizedExperiment::assayNames(se); default
#' value is "counts"
#' @param x a column name of colData which will be used in x-axis
#' @param ... other arguments to be passed to ggpubr::\code{\link{ggboxplot}}
#'
#' @return return an object of class ggarrange, which is a ggplot or a list of ggplot.
#' @export
#' @importFrom ggpubr ggboxplot facet annotate_figure
#' @rdname genes_plot
assay_plot <- function(se, feature, assayNames = c("counts"), x, ...){
    checkNameSpace("sechm")
    stopifnot("assayName not found"=(all(assayNames %in% SummarizedExperiment::assayNames(se))))
    stopifnot("features is not character or list"=(feature %in% SummarizedExperiment::rownames(se)))

    d <- sechm::meltSE(se,features = feature,assayName = assayNames )

    listPlot <- list()
    for(i in seq_len(length(assayNames))){
        listPlot[[i]] <- d %>% ggboxplot( y=assayNames[i], x=x, ...)
    }

    ggarrange(plotlist = listPlot, common.legend = TRUE, legend =  "bottom") %>%
        annotate_figure(top = text_grob(feature, color = "red", face = "bold", size = 14))
}


#' Provides GO gene set enrichment and over-representation analysis
#'
#' This wrapper function combines clusterProfiler::gseGO and
#' clusterProfiler::enrichGO. The input type of thes two methods are different;
#' order ranked geneList and a vector of entrez gene id. Here combinedEnrichment
#' function internally generates these two data types from user defined DEG_table
#' (differentially expresssed genes).
#'
#'
#' @param DEG_table A data.frame atleast with two columns.
#' @param geneCol The column name of DEG_table which provides gene ids and should
#' be compatible with keytype parameter.
#' @param logCol The column name of DEG_table which provides logfold(numeric) values to
#' create a order ranked geneList for gseGO funtion.
#' @param logfoldCut to filter genes based on parameter logCol
#' @param OrgDB OrgDb; passed to clusterProfiler functions
#' @param keyType keytype of input gene(geneCol). One of the keytypes(OrgDB); passed to clusterProfiler functions
#' @param universe background genes; passed to clusterProfiler::enrichGO.
#' @param ont one of "BP", "MF", and "CC" subontologies, or "ALL" for all three.; passed to clusterProfiler functions
#' @param pvalueCutoff ; passed to clusterProfiler functions
#' @param qvalueCutoff ; passed to clusterProfiler functions
#'
#' @return a named list of three data.frames which are output of gseGO("gseResult")
#' and enrichGO ("oraUP" and "oraDOWN").
#' @export
#'
#' @importFrom clusterProfiler enrichGO gseGO
#' @examples
combinedEnrichment <- function(DEG_table, geneCol = "ID", logCol = "logFoldChange",
                               OrgDB = "org.Hs.eg.db", keyType, universe, ont  = "BP",
                               logfoldCut = 1, pvalueCutoff  = 0.05, qvalueCutoff  = 0.05 ){

    # library(OrgDB,quietly = TRUE,character.only = T)
    requireNamespace(OrgDB,quietly = TRUE)
    stopifnot(keyType %in% keytypes(get(OrgDB)))
    ## feature 1: numeric vector
    DEGlist <- DEG_table[[logCol]]

    ## feature 2: named vector
    names(DEGlist) <- as.character(DEG_table[,geneCol])

    DEGlist <- sort(DEGlist, decreasing = TRUE)
    message("Performing: Gene Set Enrichment Analysis")
    gseResult <- gseGO(DEGlist,
                       OrgDb         = OrgDB,
                       ont           = ont,
                       # minGSSize    = 100,
                       # maxGSSize    = 500,
                       pvalueCutoff = pvalueCutoff,
                       verbose      = FALSE,
                       keyType = keyType)

    message("Performing: Over-representation analysis of UP regulated genes")
    oraUP <- enrichGO(subset(DEG_table, get(logCol) >= logfoldCut)[,geneCol],
                      universe      = universe,
                      OrgDb         = OrgDB,
                      ont           = ont,
                      pAdjustMethod = "BH",
                      pvalueCutoff  = pvalueCutoff,
                      qvalueCutoff  = qvalueCutoff,
                      readable      = TRUE,
                      keyType = keyType)

    message("Performing: Over-representation analysis of DOWN regulated genes")
    oraDOWN <- enrichGO(subset(DEG_table, get(logCol) <= -1*logfoldCut)[,geneCol],
                        universe      = universe,
                        OrgDb         = OrgDB,
                        ont           = ont,
                        pAdjustMethod = "BH",
                        pvalueCutoff  = pvalueCutoff,
                        qvalueCutoff  = qvalueCutoff,
                        readable      = TRUE,
                        keyType = keyType)

    return(list(gseResult=gseResult, oraUP= oraUP, oraDOWN = oraDOWN))
}

#' Applies round function only on numeric columns of a data.frame.
#'
#' @param df data.frame object
#' @param digits passed to \code{\link{round}}
#'
#' @return data.frame object
#' @export
#'
#' @examples
#' data("iris")
#' iris %>% round_df(digits = 0) %>% head()
round_df <- function(df, digits) {
    nums <- vapply(df, is.numeric, FUN.VALUE = logical(1))
    df[,nums] <- round(df[,nums], digits = digits)
    (df)
}

is.na2 <- function(x){
    if(is.list(x) | length(x) > 1){
        return(FALSE)
    }
    if(length(x) == 0){
        return(TRUE)
    }
    return(is.na(x))
}

## Based on https://montilab.github.io/BS831/articles/docs/DiffanalysisRNAseqComparison.html
## https://static-content.springer.com/esm/art%3A10.1038%2Fs41598-020-76881-x/MediaObjects/41598_2020_76881_MOESM1_ESM.pdf

#' @export
#' @rdname use_limma
use_limma_trend <- function(se, colData_id, control, treatment, rank=FALSE,...){
    showPlot <- FALSE
    dottedArg <- list( ...)
    if(!is.null(dottedArg$showPlot) ) showPlot <- dottedArg$showPlot

    return(use_limma(se = se, colData_id = colData_id,
                     control = control, treatment = treatment, rank = rank,
                     useVoom = FALSE, showPlot = showPlot,...))
}

#' @export
#' @rdname use_limma
use_limma_voom <- function(se, colData_id, control, treatment,rank=FALSE,...){
    showPlot <- FALSE
    dottedArg <- list( ...)
    if(!is.null(dottedArg$showPlot) ) showPlot <- dottedArg$showPlot

    return(use_limma(se = se, colData_id = colData_id,
                     control = control, treatment = treatment, rank = rank,
                     useVoom = TRUE, showPlot = showPlot,...))
}

#' To use SummarizedExperiment with package limma
#'
#' A wrapper function of limma where input is an object of \code{\link{SummarizedExperiment}}
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' additional column named "rank"
#' @param useVoom whether to use limma::voom or edgeR::cpm
#' @param showPlot whether to use limma::plotSA ; default FALSE
#' @param ... other arguments to be passed to main function edgeR::calcNormFactors .
#' @param limma.adjust argument for limma::topTable
#' @param limma.sort.by argument for limma::topTable
#' @param limma.number argument for limma::topTable
#'
#' @return a data.frame of output from limma::topTable
#'
#' @export
#' @importFrom dplyr %>% left_join
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#' result <-
#'     use_limma(se = se,
#'            colData_id = "stage", control = "Bud", treatment = "Cap",
#'            rank = TRUE)
use_limma <- function(se, colData_id, control, treatment,
                      rank=FALSE, useVoom=TRUE, showPlot=FALSE,
                      limma.adjust="BH", limma.sort.by = "p", limma.number=Inf,
                      ...) {
    checkNameSpace("limma")
    checkNameSpace("edgeR")
    se <- se[,se[[colData_id]] %in% c(control,treatment)]
    # dim(se)
    condition <- factor(as.character(SummarizedExperiment::colData(se)[,colData_id]),
                        levels = c(control,treatment))

    design <- stats::model.matrix(~ 0 + condition)
    colnames(design) <- c(control,treatment)

    command_str <- paste("limma::makeContrasts(",treatment , "-", control,",levels = design)"
                         , sep = "")
    contrast.matrix <- eval(parse(text=command_str))

    ##Normalizing
    dge <- edgeR::calcNormFactors(se, ...)

    if(showPlot & useVoom){
        par(mfrow=c(1,2))
    } else {
        par(mfrow=c(1,1))
    }
    if(useVoom){
        v <- limma::voom(dge, design, plot=showPlot)
        fit <- limma::lmFit(v, design)
    }else{
        ## Differential expression: Limma trend
        ## convert counts to logCPM
        logCPM <- edgeR::cpm(dge,log=TRUE,priot.count=3)
        fit <- limma::lmFit(logCPM, design )
    }

    fit <- limma::contrasts.fit(fit, contrast.matrix)
    fit <- limma::eBayes(fit,trend = !useVoom)

    res <- limma::topTable(fit, coef=1, adjust=limma.adjust,
                           sort.by = limma.sort.by, number=limma.number,
                           ...)
    if(isTRUE(showPlot)){
        limma::plotSA(fit, main="Final model: Mean-variance trend")
    }
    if(rank){
        return(res %>% dplyr::select(logFC:B) %>%
                   dplyr::mutate(rank := 1:dplyr::n()) )
    }else{
        return(res)
    }
}

#' @export
#' @rdname use_edgeR
use_edgeR_GLM <- function(se, colData_id, control, treatment, rank=FALSE,...){
    return(use_edgeR(se = se, colData_id = colData_id,
                     control = control, treatment = treatment, rank = rank,
                     option="GLM",...))
}

#' @export
#' @rdname use_edgeR
use_edgeR_exact <- function(se, colData_id, control, treatment, rank=FALSE,...){
    return(use_edgeR(se = se, colData_id = colData_id,
                     control = control, treatment = treatment, rank = rank,
                     option = "exact",...))
}


#' To use SummarizedExperiment with package edgeR
#'
#' A wrapper function of DESeq2 where input is an object of \code{\link{SummarizedExperiment}}
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' additional column named "rank"
#' @param edgeR.n argument for edgeR::\code{\link{topTags}}
#' @param edgeR.adjust.method argument for edgeR::\code{\link{topTags}}
#' @param edgeR.sort.by argument for edgeR::\code{\link{topTags}}
#' @param option "GLM" or "exact" to indicate to use either edgeR::\code{\link{glmLRT}}
#' or edgeR::\code{\link{exactTest}}
#' @param ... other arguments to be passed to edgeR::\code{\link{glmLRT}}
#' or edgeR::\code{\link{exactTest}}
#'
#' @return a data.frame of output from edgeR::\code{\link{topTags}}
#' @export
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#'
#' result <-
#'     use_edgeR(se = se,
#'            colData_id = "stage", control = "Bud", treatment = "Cap",
#'            rank = TRUE)
use_edgeR <- function(se, colData_id, control, treatment, rank=FALSE,
                      edgeR.n = Inf, edgeR.adjust.method = "BH", edgeR.sort.by = "PValue",
                      option="GLM",...){
    checkNameSpace("edgeR")
    stopifnot("option must be either 'GLM' or 'exact'"=(option=="GLM" | option=="exact"))
    se <- se[,se[[colData_id]] %in% c(control,treatment)]
    condition <- factor(as.character(SummarizedExperiment::colData(se)[,colData_id]),
                        levels = c(control,treatment))

    ##Normalizing
    dt <- edgeR::calcNormFactors(se,method="TMM")
    ##Normalization

    if(option=="GLM"){
        design <- stats::model.matrix(~ 0 + condition)
        colnames(design) <- c(control,treatment)

        d2 <- edgeR::estimateGLMCommonDisp(dt,design)
        d2 <- edgeR::estimateGLMTrendedDisp(d2,design, method="auto")
        # Possible method to "auto", "bin.spline", "power", "spline", "bin.loess".
        # "auto" chooses "bin.spline" when > 200 tags and "power" otherwise
        d2 <- edgeR::estimateGLMTagwiseDisp(d2,design)
        fit <- edgeR::glmFit(d2,design)

        command_str <- paste("limma::makeContrasts(",treatment , "-", control,
                             ",levels = design)" , sep = "")
        contrast.matrix <- eval(parse(text=command_str))
        t12 <- edgeR::glmLRT(fit,contrast=contrast.matrix,...)
    }else if(option=="exact"){
        ##Estimate dispersion
        dt$samples$group <- condition
        d1 <- edgeR::estimateCommonDisp(dt, verbose=TRUE)
        d1 <- edgeR::estimateTagwiseDisp(d1)
        ##Compare groups (exact test)
        t12 <- edgeR::exactTest(d1, pair=c(1,2),...)
    }
    res <- edgeR::topTags(t12, n=edgeR.n, sort.by = edgeR.sort.by ,
                          adjust.method = edgeR.adjust.method,
                          ...) %>% as.data.frame()
    if(rank){
        return(res %>% dplyr::select(logFC:FDR)%>%
                   dplyr::mutate(rank := 1:dplyr::n()) )
    }else{
        return(res)
    }
}

#' To use SummarizedExperiment with package DESeq2
#'
#' A wrapper function of DESeq2 where input is an object of \code{\link{SummarizedExperiment}}
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' additional column named "rank" and the results are ranked on "padj"
#' @param ...  other arguments to be passed to main function DESeq2::\code{\link{results}}.
#'
#' @return a data.frame converted from DESeq2::\code{\link{DESeqResults}}
#' @export
#' @importFrom dplyr %>% left_join
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#'
#' result <-
#'     use_deseq2(se = se,
#'            colData_id = "stage", control = "Bud", treatment = "Cap",
#'            rank = TRUE)
use_deseq2 <- function(se, colData_id, control, treatment,rank=FALSE,...){
    checkNameSpace("DESeq2")
     if (SummarizedExperiment::assayNames(se)[1] != "counts") {
         nuOrder <-
             c("counts",
               setdiff(SummarizedExperiment::assayNames(se), "counts"))
         SummarizedExperiment::assays(se) <-
             SummarizedExperiment::assays(se)[nuOrder]
     }
     se <- se[,se[[colData_id]] %in% c(control,treatment)]

    formula_str <- paste("formula( ~ ",colData_id, ")", sep = "")
    dds <- DESeq2::DESeqDataSet(se, design = eval(parse(text=formula_str)))

    ## set reference to control, otherwise default is alphabetical order
    dds[[colData_id]] <- factor(dds[[colData_id]], levels=c(control,treatment))

    ##   1. estimate size factors
    ##   2. estimate dispersion
    ##   3. negative binomial GLM fitting and wald test
    dds_res <- DESeq2::DESeq(dds)
    res <- DESeq2::results(dds_res,...)
    # res$dispersion <- DESeq2::dispersions(dds_res)
    if(rank){
        return(res %>% as.data.frame() %>%
               dplyr::arrange(padj) %>%
               dplyr::mutate(rank = 1:dplyr::n()))
    }else{
        return(res)
    }
}

#' To use SummarizedExperiment with package DELocal
#'
#' A wrapper function of DELocal where input is an object of \code{\link{SummarizedExperiment}}
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of
#' more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' additional column named "rank" and the results are ranked on "relative.logFC"
#'
#' @param ... other arguments to be passed to main function DELocal::\code{\link{DELocal}}.
#'
#' @return a data.frame from DELocal
#' @export
#' @importFrom dplyr %>% left_join
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#'
#' result <-
#'     use_DELocal(se = se,
#'            colData_id = "stage", control = "Bud", treatment = "Cap",
#'            rank = TRUE)
use_DELocal <- function(se, colData_id, control, treatment,rank=FALSE,...){
    checkNameSpace("DELocal")
    formula_str <- paste("formula( ~ ",colData_id, ")", sep = "")
    if (SummarizedExperiment::assayNames(se)[1] != "counts") {
        nuOrder <-
            c("counts",
              setdiff(SummarizedExperiment::assayNames(se), "counts"))
        SummarizedExperiment::assays(se) <-
            SummarizedExperiment::assays(se)[nuOrder]
    }

    se <- se[,se[[colData_id]] %in% c(control,treatment)]
    se[[colData_id]] <- factor(se[[colData_id]],levels = c(control, treatment))

    DELocal_result <- DELocal::DELocal(pSmrExpt = se, # Genes without neighbours are missing
                              nearest_neighbours = 5, pDesign =eval(parse(text=formula_str)),
                              pValue_cut = 1, pLogFold_cut = 0,...)
    if(rank){
        return(DELocal_result %>%
                   dplyr::arrange(desc(abs(relative.logFC))) %>%
                   dplyr::mutate(rank = 1:dplyr::n()))
    }else{
        return(DELocal_result)
    }
}



#' To use SummarizedExperiment with package EBSeq
#'
#' A wrapper function of EBSeq where input is an object of \code{\link{SummarizedExperiment}}
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of
#' more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' additional column named "rank" and the results are ranked on "PPDE"
#' @param ... other arguments to be passed to main function EBSeq::\code{\link{GetDEResults}}.
#'
#' @return a data.frame object converted from the output of EBSeq::\code{\link{GetDEResults}}.
#' @export
#' @importFrom dplyr %>% left_join
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#'
#' result <-
#'     use_EBSeq(se = se,
#'            colData_id = "stage", control = "Bud", treatment = "Cap",
#'            rank = TRUE)
use_EBSeq <- function(se, colData_id, control, treatment, rank=FALSE,...){
  checkNameSpace("EBSeq")
  control_names <- se[,se[[colData_id]]==control] %>% colnames()
  treatment_names <- se[,se[[colData_id]]==treatment] %>% colnames()
  tabla <- SummarizedExperiment::assays(se)[["counts"]][,c(control_names,treatment_names)]
  Sizes <- EBSeq::MedianNorm(tabla)
  
  EBOut <- EBSeq::EBTest(Data=tabla,
                         Conditions=factor(c(rep(control,length(control_names)),
                                             rep(treatment,length(treatment_names))),
                                           levels = c(treatment, control)),
                         sizeFactors=Sizes, maxround=5, 
                         QtrmCut = -1) ## to get all the transcripts
  EBDERes <- EBSeq::GetDEResults(EBOut, ...)
  ##Calculate FC
  FC <- EBSeq::PostFC(EBOut, SmallNum = 0.01)
  
  ##Obtain probabilities
  res <- data.frame(PPEE=EBDERes$PPMat[,"PPEE"] ,PPDE=EBDERes$PPMat[,"PPDE"],Status=EBDERes$Status,
                    RealFC=FC$RealFC) #,PostFC=FC$PostFC, Direction = FC$Direction
  # Do not use FC$Direction which is single value
  res <- res %>% dplyr::mutate(
    signedRealFC = ifelse((RealFC < 1 & Status == "DE"), -(1/RealFC), RealFC))
  
  if(rank){
    res %>% dplyr::arrange(desc(PPDE)) %>%
      dplyr::mutate(rank = 1:dplyr::n())
  }else{
    res
  }
}


#' Differential expression method for NOISeq
#'
#' This is a wrapper function of NOISeq::\code{\link{noiseqbio}} whose input class is ´eSet´
#' and output class is `Output` which are not widely used. We can use as(se, "ExpressionSet")
#' to get an eSet easily but then it will be hard to refer the treatment and control.
#' The order of factors influence the log fold change sign. To keep it comparable
#' to other methods the `NOISeq::readData()` is used internally.
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' additional column named "rank" which is ordered by ´prob´ values returned by
#' function NOISeq::\code{\link{noiseqbio}}.
#' @param ...  other arguments to be passed to main function NOISeq::\code{\link{noiseqbio}}.
#' The 'input' and 'factor' argument should not be used.
#'
#' @return A data.frame object from the results of NOISeq::noiseqbio(). For details check
#' the documentation of ´NOISeq´
#' @export
#' @importFrom dplyr %>% left_join
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#'
#' result_Noiseq <-
#'     use_NOIseq(se = se,
#'            colData_id = "stage", control = "Bud", treatment = "Cap",
#'            rank = TRUE,
#'            r = 10) # r is an argument of NOISeq::noiseqbio
use_NOIseq <- function(se, colData_id, control, treatment, rank=FALSE, ...){
    control_names <- se[,se[[colData_id]]==control] %>% colnames()
    treatment_names <- se[,se[[colData_id]]==treatment] %>% colnames()
    tabla <- SummarizedExperiment::assays(se)[["counts"]][,c(control_names,treatment_names)] %>% as.data.frame()

    expt_factors <- data.frame(Condition = factor(c(
        rep(control, length(control_names)),
        rep(treatment, length(treatment_names))
    ), levels = c(treatment,control)))
    colnames(expt_factors) <- colData_id
    expt_data <- NOISeq::readData(data = tabla, factors = expt_factors)

    ##Available normalization methods: norm = "rpkm", "uqua", "tmm2, "none"
    expt_noiseqbio <- NOISeq::noiseqbio(input= expt_data, factor=colData_id, ...)

    if(rank){
        expt_noiseqbio@results[[1]] %>%
            dplyr::arrange(desc(prob)) %>%
            dplyr::mutate(rank = 1:dplyr::n())
    }else{
        expt_noiseqbio@results[[1]]
    }
}

#' To use SummarizedExperiment with package samr
#'
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param rank Logical value default FALSE. If true the result will have an
#' @param ... other arguments to be passed to samr::SAMseq
#'
#' @return a data.frame object as a result
#' @importFrom dplyr %>% left_join
#' @importFrom stringr str_remove
#' @examples
#'
use_SAMseq <- function(se, colData_id, control, treatment,rank = FALSE,...){
    checkNameSpace("samr")
    control_names <- se[,se[[colData_id]]==control] %>% colnames()
    treatment_names <- se[,se[[colData_id]]==treatment] %>% colnames()
    tabla <- SummarizedExperiment::assays(se)[["counts"]][,c(control_names,treatment_names)] %>% as.data.frame()
    y <- factor(c(rep(control,length(control_names)),
                 rep(treatment,length(treatment_names))),
               levels = c(control,treatment))

    # it uses cat() for lots of text, annoying
    samfit <- samr::SAMseq(tabla, y, resp.type = "Two class unpaired",
                           geneid = rownames(tabla), genenames = rownames(tabla),
                           random.seed=1, fdr.output = 1,...)
    if(is.null(samfit$siggenes.table$genes.up) & is.null(samfit$siggenes.table$genes.lo)){
        return(NULL)
    }else if(is.null(samfit$siggenes.table$genes.up)) {
        res <- as.data.frame(samfit$siggenes.table$genes.lo)
        res[,"Fold Change"] <- as.numeric(res[,"Fold Change"]) * (-1)
    }else if(is.null(samfit$siggenes.table$genes.lo)) {
        res <- as.data.frame(samfit$siggenes.table$genes.up)
    }else{
        down <- as.data.frame(samfit$siggenes.table$genes.lo)
        down[,"Fold Change"] <- as.numeric(down[,"Fold Change"]) * (-1)
        res <- rbind(as.data.frame(samfit$siggenes.table$genes.up),down)
    }
    colnames(res) <- colnames(res) %>% stringr::str_remove(" ")
    missing_id <- setdiff(rownames(se),res$GeneID)
    missing_data <- data.frame(GeneID=missing_id, GeneName=missing_id,
                               `Score(d)` = NA, 'FoldChange' = NA, `q-value(%)` = NA)
    colnames(missing_data) <- colnames(res)

    res <- rbind(res,missing_data)
    row.names(res) <- res$GeneID

    res <- res %>% as.data.frame() %>% dplyr::mutate_at(c('Score(d)', 'FoldChange', 'q-value(%)'), as.numeric)

    res <- res %>% dplyr::select('Score(d)': 'q-value(%)')

    if(rank){
        res <- res %>%
         dplyr::arrange(as.numeric(`q-value(%)`))  %>%
         dplyr::mutate(rank = 1:dplyr::n())
    }

    return(res)
}

#' To identify differentially expressed genes by multiple methods
#'
#' @param deFun_list a list of function which can perform differential expression analysis
#' @param return.df whether to return all results aggregated form of data.frame or
#' a list of results. Default is FALSE
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param colData_id One of the columns of colData(se). It should be factors of more than one value.
#' @param control Base level and one of the factor values of `colData(se)[[colData_id]]`
#' @param treatment one of the factor values of `colData(se)[[colData_id]]`
#' @param ... other arguments to be passed to functions listed in deFun_list
#'
#' @importFrom purrr reduce
#' @return a list or data.frame
#' @export
#'
#' @examples
#'
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' # To reduce runtime
#' se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
#'
#' # First define a named list of functions
#' funs <- list(limma_trend = use_limma_trend, limma_voom = use_limma_voom,
#'              edgeR_exact = use_edgeR_exact, edgeR_glm = use_edgeR_GLM,
#'              deseq2 = use_deseq2,
#'              DELocal = use_DELocal, noiseq = use_NOIseq,
#'              EBSeq = use_EBSeq)
#'
#'
#' multi_result <- broadSeq::use_multDE(
#'     se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"],
#'     deFun_list = funs, return.df = TRUE,
#'     colData_id = "stage", control = "Bud", treatment = "Cap",
#'     rank = TRUE)
use_multDE <- function(deFun_list, return.df= FALSE ,se ,
                       colData_id , control , treatment , ... ) {
    wrap_it <- function( f, ...) {
        message(paste("Now executing >> ",f))
        message("####")
        deFun_list[[f]](... )
    }
    SummarizedExperiment::colData(se)[,colData_id] %>% summary()

    y <- lapply(names(deFun_list), wrap_it, se = se, colData_id = colData_id,
                control = control, treatment = treatment, ...)

    named_result <- list()
    for (i in seq_len(length(y))) {
        named_result[[names(deFun_list)[i]]] <- y[[i]]
    }
    y <- named_result

    if(return.df){
        for (prefix in names(y)) {
            colnames(y[[prefix]]) <- paste(prefix,colnames(y[[prefix]]), sep = "_")
        }

        y <- purrr::reduce(lapply(y, function(x) data.frame(x, rn = row.names(x))),
                           merge, all=TRUE)
        gene_info <- as.data.frame(SummarizedExperiment::rowData(se))
        rownames(y) <- y$rn
        y$rn <- NULL
        y <- purrr::reduce(lapply(list(y,gene_info),
                                function(x) data.frame(x, rn = row.names(x))),
                         merge, all.x=TRUE)
        rownames(y) <- y$rn
        y$rn <- NULL
    }
    return(y)
}

#' Volcano plot with formatted x and y axis label.
#'
#' @param df a data.frame object
#' @param pValName column name of df which provides p-values
#' @param lFCName column name of df which provides log fold change values
#' @param sigThreshold Threshold for p-values
#' @param logFCThreshold Threshold for log fold change values
#' @param labelName column name of df to label the dots
#' @param selectedLabel which dots to highlight
#' @param palette one of "npg" ,"aaas", "lancet", "jco", "ucscgb", "uchicago",
#' "simpsons" and "nejm" or similar to viridis::cividis(3)
#' @param color To color the points, default NULL to color based on significance 
#'and logFold threshold otherwise must be a column name of df
#'
#' @return ggplot object
#' @export
#' @importFrom dplyr %>% left_join if_else
#' @importFrom ggpubr ggscatter
#' @examples
volcanoPlot <- function(df, pValName, lFCName, 
                        color=NULL, sigThreshold = 0.05, logFCThreshold = 1, 
                        labelName = NULL, selectedLabel = NULL, palette = "nejm") 
{
  df <- df %>% dplyr::mutate(padj = -log10(!!sym(pValName)),
                             Significant = if_else((!!sym(pValName) < sigThreshold &
                                                      !!sym(lFCName) > logFCThreshold),
                                                   "UP",
                                                   if_else(
                                                     (!!sym(pValName) <  sigThreshold &
                                                        !!sym(lFCName) < -logFCThreshold
                                                     ),"DOWN","Not",missing = "Not"
                                                   ), missing = "Not"
                             )
  )
  df$Significant <- factor(df$Significant, levels = c("DOWN", "UP", "Not"))
  if(is.null(color)){ color <- "Significant"}
  plot <- df %>% ggscatter(x = lFCName, y = "padj", color = color, 
                           palette = palette, title = "Volcano plot", label = labelName, 
                           repel = TRUE, label.rectangle = TRUE, show.legend = FALSE, 
                           label.select = selectedLabel) + 
    labs(x = expression("log"[2] * "FC"), y = expression("-log"[10] * "p-value")) + 
    geom_abline(intercept = -log10(sigThreshold),  slope = 0, linetype = "dashed")
  return(plot)
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup, include = FALSE---------------------------------------------------
library(broadSeq)

## ----fig.cap = "Input and output data structures of different methods to idetify differentially expressed genes.", echo = FALSE----
knitr::include_graphics("img/io_p.png")

## ----echo = FALSE,fig.cap="Flowchart"-----------------------------------------
knitr::include_graphics("img/broadSeq.png")

## ----eval = FALSE-------------------------------------------------------------
# library(broadSeq)
# library(ggplot2)

## ----message=FALSE------------------------------------------------------------
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))
SummarizedExperiment::assayNames(se)

## -----------------------------------------------------------------------------
as.data.frame(colData(se)) %>% dplyr::count(stage,species) %>% tidyr::spread(stage,n)

se$stage <- factor(se$stage,levels = c("Bud","Cap","Late Cap","Bell"))

## ----lowExpr,warning=FALSE,fig.width= 6---------------------------------------
assays(se)[["counts"]][,5] %>% ggpubr::ggdensity(y = "count")+
    ggplot2::geom_vline(xintercept = 10)+ggplot2::scale_x_log10()

keep <- (assays(se)[["counts"]] >= 3) %>% rowSums() >= 5 
# smallest Group Size is 5
table(keep)

## ----warning=FALSE,message=FALSE----------------------------------------------
se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
## The normalized values are added with the assay name "logCPM"
SummarizedExperiment::assayNames(se)

## ----warning=FALSE,message=FALSE----------------------------------------------
se <- broadSeq::normalizeEdgerCPM(se , method = "TMM", cpm.log = FALSE )
## The normalized values are added with the assay name "TMM"
SummarizedExperiment::assayNames(se)

## -----------------------------------------------------------------------------
assays(se)[["counts"]][1:5,1:5]
assays(se)[["TMM"]][1:5,1:5]
assays(se)[["logCPM"]][1:5,1:5]

## ----warning=FALSE------------------------------------------------------------
se <- broadSeq::transformDESeq2(se,method = "vst"  )

## -----------------------------------------------------------------------------
se <- broadSeq::transformDESeq2(se, method = "normTransform"  )

## ----eval=FALSE---------------------------------------------------------------
# se <- broadSeq::transformDESeq2(se, method = "rlog")

## -----------------------------------------------------------------------------
SummarizedExperiment::assayNames(se)

## ----warning=FALSE,fig.height=6,fig.width=8-----------------------------------
p <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse" ], 
                           assayName = "counts", fill = "stage", 
                           yscale = "log2")+ rremove("x.text")

p1 <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse"], 
                           assayName = "vst", fill = "stage")+ rremove("x.text")

p2 <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse"], 
                           assayName = "TMM", fill = "stage", 
                           yscale = "log10")+ rremove("x.text")

p3 <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse"], 
                           assayName = "logCPM", fill = "stage")+ rremove("x.text")


ggarrange(p,p1,p2,p3, common.legend = TRUE, labels = c("A","B","C"))

## ----eval=FALSE---------------------------------------------------------------
# if (requireNamespace("vsn", quietly = TRUE)) {
#     library("vsn")
#     x <- meanSdPlot(
#         log2(assays(se[, se$species == "Rat"])[["counts"]]+1),
#         plot = FALSE)
#     print(x$gg +ggtitle(label = "log2(n+1) "))
# 
#     x <- meanSdPlot(
#         assays(se[, se$species == "Rat"])[["vst"]],
#         plot = FALSE)
# 
#     print(x$gg +ggtitle(label = "Vst"))
# 
#     x <- meanSdPlot(
#         assays(se[, se$species == "Rat"])[["logCPM"]],
#         plot = FALSE)
#     print(x$gg + ggtitle(label = "logCPM"))
# }
# 

## ----message=FALSE,warning=FALSE----------------------------------------------
## Multiple assay of a single gene
broadSeq::assay_plot(se, feature = c("Shh"), 
           assayNames = c("counts","logCPM","vst","TMM"),
           x = "stage", fill="species", add="dotplot", palette = "npg")

## Expression of multiple genes from a single assay
broadSeq::genes_plot(se, 
                     features = c("Shh","Edar"), 
                     facet.by = "symbol",
                     x = "stage", assayName = "vst", color="species", palette = "jco")

## ----warning=FALSE,message=FALSE,fig.height=6,fig.width=8---------------------
jco <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol", assayName =  "logCPM",
                     x = "stage",  fill="stage", add="dotplot", xlab = "", 
                     add.params = list(size= 0.5), 
                     caption = "Journal of Clinical Oncology", palette = "jco") 

npg <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol",assayName =  "logCPM",
                     x = "stage", fill="stage", add="dotplot", xlab = "", 
                     add.params = list(size= 0.5),
                     caption = "Nature Publishing Group", palette = "npg") 

aaas <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol", assayName = "logCPM",
                     x = "stage", fill="stage", add="dotplot", xlab = "", 
                     add.params = list(size= 0.5),
                     caption = "Science", palette = "aaas")

nejm <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol", assayName = "logCPM",
                     x = "stage", color="stage", add="dotplot",  xlab = "", 
                     add.params = list(size= 0.5),
                     caption = "New England \nJournal of Medicine",palette = "nejm")

# ggarrange(jco,npg,aaas,nejm, 
#           common.legend = TRUE,legend = "none",
#           labels = c("A","B","C","D"))

ggarrange(jco+ggpubr::rotate_x_text(), npg+ggpubr::rotate_x_text(),
          aaas+ggpubr::rotate_x_text(),nejm+ggpubr::rotate_x_text(),
          nrow = 1, common.legend = TRUE,legend = "none",
          labels = c("A","B","C","D")) %>% 
    annotate_figure( top = text_grob("Color palette")) 

## ----fig.height=6,fig.width=8-------------------------------------------------
broadSeq::plot_MDS(se, scaledAssay = "vst", ntop=500, 
                   color = "species", shape = "stage", 
                   ellipse=TRUE, legend = "bottom")

## -----------------------------------------------------------------------------
head(rowData(se))

## ----fig.height=6,fig.width=8-------------------------------------------------
p_vst <- broadSeq::plotHeatmapCluster(
    se,
    scaledAssay = "vst",
    annotation_col = c("species", "stage"),
    annotation_row = c("Class","gene_biotype"),
    ntop = 30, show_geneAs = "symbol",
    cluster_cols = TRUE, cluster_rows = FALSE,
    show_rownames = TRUE, show_colnames = FALSE,
    main = "Top 30 variable gene vst"
)

## ----warning=FALSE------------------------------------------------------------
computedPCA_logCPM <- broadSeq::prcompTidy(se, scaledAssay = "logCPM", ntop = 500)
## PCA based on vst values
computedPCA_vst <- broadSeq::prcompTidy(se, scaledAssay = "vst", ntop = 500)

## ----fig.width=8,fig.height=6-------------------------------------------------
plotAnyPC(computedPCA = computedPCA_logCPM,
          x = 1, y = 2, color = "species", shape = "stage",
          legend = "bottom")

## ----fig.width=8,fig.height=6-------------------------------------------------
pca_vst <- plotAnyPC(computedPCA = computedPCA_vst,
            x = 2, y = 3,  color = "species", shape = "stage", 
            legend = "bottom") 

## ----fig.width=8,fig.height=6-------------------------------------------------
computedPCA_vst$eigen_values %>%
        dplyr::filter(var_exp >= 2) %>%
    ggbarplot(x="PC",y="var_exp", label = TRUE, label.pos = "out")

## ----fig.width=8,fig.height=6-------------------------------------------------
pca_vst_2_3 <-plotAnyPC(computedPCA = computedPCA_vst,
                x = 2, y = 3,  
                color = "species", shape = "stage", legend = "bottom")
# pca_vst_2_3

## ----fig.width=7,fig.height=6-------------------------------------------------
computedPCA_vst %>% broadSeq::getFeatureLoadRanking(keep = c("symbol","Class")) %>% head()

#  Top 5 genes of PC2

computedPCA_vst$loadings %>% top_n(5,abs(PC2)  ) %>% dplyr::select(gene,PC2)

pca_vst_loading <- computedPCA_vst %>% 
    broadSeq::getFeatureLoadRanking(keep = c("symbol","Class"), topN = 50, pcs=1:10) %>% 
    dplyr::count(Class, PC) %>%
    ggbarplot(
        x = "PC", y = "n", fill = "Class",
        legend = "bottom", palette = c("red","blue","orange","purple","white","grey")
    ) 
# pca_vst_loading

## ----fig.width=8,fig.height=6-------------------------------------------------
# By default it plots top 2 genes from each PC axis
pca_vst_bi <- broadSeq::biplotAnyPC(computedPCA = computedPCA_vst, 
            x = 1, y = 2, genesLabel = "symbol", 
            color = "species", shape = "stage", 
            legend = "bottom")
# pca_vst_bi

## ----fig.width=8,fig.height=8-------------------------------------------------
ggarrange(
    ggarrange(pca_vst_bi+ggtitle(label =  ""),
          pca_vst_2_3+ggtitle(label =  ""), common.legend = TRUE),
    pca_vst_loading, nrow = 2)


## ----fig.width=8,fig.height=6-------------------------------------------------
# Top 5 genes of PC3
biplotAnyPC(computedPCA = computedPCA_vst,x = 2, y = 3, 
            color = "species", shape = "stage",
            genes= computedPCA_vst$loadings %>% 
                top_n(5,abs(PC3)) %>% pull(gene),
            genesLabel = "symbol")

## Plot progression gene "Shh" 
biplotAnyPC(computedPCA = computedPCA_vst,x = 2, y = 3, 
            color = "species", shape = "stage",
            genes=c("Shh"),
            genesLabel = "symbol")

## ----warning=FALSE,eval=TRUE--------------------------------------------------
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))

# To reduce the run time, subset of the data used here
se <- se[,colData(se)$species == "Mouse"]

## ----warning=FALSE,eval=FALSE,echo=FALSE--------------------------------------
# count_matrix <- as.matrix(read.table(file = system.file("extdata",
#                                               "tooth_RNASeq_counts.txt",
#                                               package = "DELocal")))
# colData <- data.frame(condition=gsub("\\..*",x=colnames(count_matrix),replacement = ""))
# 
# gene_location <- read.table(file = system.file("extdata",
#                                               "gene_location.txt",
#                                               package = "DELocal"))
# 
# se <- SummarizedExperiment::SummarizedExperiment(assays=list(counts=count_matrix),
#                                                       rowData = gene_location,
#                                                       colData=colData)
# # contrast= c("condition","ME13","ME14")

## ----warning=FALSE------------------------------------------------------------
head(rownames(se))
head(rowData(se))

## ----warning=FALSE,eval=TRUE--------------------------------------------------
head(colData(se))
table(colData(se)$stage)

## ----warning=FALSE,fig.width=6,fig.height=6,message=FALSE---------------------
result_Noiseq <- 
    use_NOIseq(se = se, 
           colData_id = "stage", control = "Bud", treatment = "Cap",
           rank = TRUE, 
           r = 10) # r is an argument of NOISeq::noiseqbio

head(result_Noiseq)

## ----warning=FALSE,fig.width=8,fig.height=6,message=FALSE---------------------
pg <- broadSeq::genes_plot(se, x = "stage", assayName =  "counts",  
           features = result_Noiseq %>% dplyr::filter(rank <5) %>% rownames(),
           fill="stage", facet.by = "symbol",
           palette="jco", add = "dotplot") +rotate_x_text()

pg_sc <- ggscatter(result_Noiseq, x="Bud_mean", y="Cap_mean",color = "prob")+ 
    scale_x_log10()+scale_y_log10()

pg+pg_sc

## ----warning=FALSE,results="hide", fig.keep = "none"--------------------------
# limma 
?use_limma_trend(se, colData_id, control, treatment, rank = FALSE, ...)
?use_limma_voom(se, colData_id, control, treatment, rank = FALSE, ...)

# edgeR 
?use_edgeR_exact(se, colData_id, control, treatment, rank = FALSE, ...)
?use_edgeR_GLM(se, colData_id, control, treatment, rank = FALSE, ...)

# deseq2
?use_deseq2(se, colData_id, control, treatment, rank = FALSE, ...)

# DELocal
?use_DELocal(se, colData_id, control, treatment, rank = FALSE, ...)

# noiseq
?use_NOIseq(se, colData_id, control, treatment, rank = FALSE, ...) 

# EBSeq 
?use_EBSeq(se, colData_id, control, treatment, rank = FALSE, ...)

# samseq
?use_SAMseq(se, colData_id, control, treatment, rank = FALSE, ...)

## ----warning=FALSE,results="hide", fig.keep = "none"--------------------------
# First define a named list of functions
funs <- list(limma_trend = use_limma_trend, limma_voom = use_limma_voom,
             edgeR_exact = use_edgeR_exact, edgeR_glm = use_edgeR_GLM,
             deseq2 = use_deseq2, 
             DELocal = use_DELocal, noiseq = use_NOIseq, 
             EBSeq = use_EBSeq) 


multi_result <- broadSeq::use_multDE(
    se = se, 
    deFun_list = funs, return.df = TRUE,  
    colData_id = "stage", control = "Bud", treatment = "Cap", 
    rank = TRUE)

## ----warning=FALSE------------------------------------------------------------
head(multi_result)
# nrow(multi_result) == nrow(se)
colnames(multi_result)

## ----warning=FALSE,fig.width=6,fig.height=6,eval=TRUE-------------------------
clusters <- multi_result %>% dplyr::select(ends_with("rank")) %>% t() %>% dist() %>% hclust()
plot(clusters,main =  "distance: Euclidean")

## ----warning=FALSE,fig.width=6,fig.height=6,eval=TRUE-------------------------
multi_result %>% broadSeq::volcanoPlot(
    pValName = "deseq2_padj",
    lFCName = "deseq2_log2FoldChange",
    labelName = "symbol",
    palette = "lancet" ,
    selectedLabel =
        multi_result %>% dplyr::arrange(deseq2_padj) %>% pull(symbol) %>% head()
)

multi_result %>% broadSeq::volcanoPlot(
    pValName = "deseq2_padj",
    lFCName = "deseq2_log2FoldChange",
    labelName = "symbol",
    palette = c("purple","orange","grey"),
    selectedLabel = list(criteria = "(`x` > 5 | `x` < -2) & (`y` > 10)")
) +xlim(-7.5,7.5)

## ----warning=FALSE,fig.width=6,fig.height=6,eval=TRUE-------------------------
multi_result %>% broadSeq::volcanoPlot(
    pValName = "deseq2_padj",
    lFCName = "deseq2_log2FoldChange",
    labelName = "symbol",
    color = "Class",
    palette = "lancet",
    selectedLabel = list(criteria = "(Class %in% c('Progression','Shape')) & (`y` > 10)")
) +xlim(-7.5,7.5)

## ----warning=FALSE,error=FALSE------------------------------------------------
sessionInfo()

#' Use of edgeR package to normalize count data
#'
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param cpm.log value for edgeR::\code{\link{cpm}} function. default TRUE
#' @param method value for edgeR::\code{\link{normLibSizes}} function. default "TMM"
#' @param ... passed to normLibSizes function
#'
#' @return Object of \code{\link{SummarizedExperiment}} class where a new assay
#' is added to the input object.
#' @export
#' @import edgeR
#'
#' @examples
#' se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' se <- broadSeq::normalizeEdgerCPM(se , method = "TMM", cpm.log = FALSE )
#' # The normalized values are added with the assay name "TMM"
#' SummarizedExperiment::assayNames(se)
normalizeEdgerCPM <- function(se, method="TMM", cpm.log = TRUE, ...){
    stopifnot(is(se, "SummarizedExperiment"))
    x<- normLibSizes(se,method=method,...)
    x<- cpm(x,log=cpm.log)
    assay_name <- ifelse(cpm.log,"log","") #if_else is better to handle na values
    assay_name <- paste(assay_name,
                        ifelse(method != "none",
                               method, "CPM"), sep = "")
    message("New assay name ",assay_name)
    SummarizedExperiment::assays(se)[[assay_name]] <- x
    return(se)
}

#' Transform SummarizedExperiment with DESeq2 package
#'
#' To use SummarizedExperiment with DESeq2, this function makes sure that 'counts'
#' assay should be the first in assays list and the mode is integer.
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param method "vst", "normTransform" or "rlog" to choose either of DESeq2::\code{\link{varianceStabilizingTransformation}}
#' DESeq2::\code{\link{normTransform}} and DESeq2::\code{\link{rlog}} function.
#' default is "vst"
#' @param ... arguments passed to \code{\link{varianceStabilizingTransformation}}
#' \code{\link{normTransform}} and \code{\link{rlog}}
#'
#' @return Object of \code{\link{SummarizedExperiment}} class where a new assay
#' is added to the input object.
#'
#' @export
#' @import DESeq2
#' @importFrom SummarizedExperiment assays
#'
#' @examples
#'  se <- readRDS(system.file("extdata",
#'         "rat_vole_mouseSE_salmon.rds",
#'         package = "broadSeq"))
#'
#' se <- broadSeq::transformDESeq2(se,method = "vst"  )
#' # The transformed values are added with the assay name "vst"
#' SummarizedExperiment::assayNames(se)
transformDESeq2 <- function(se, method="vst", ...){
    stopifnot(is(se, "SummarizedExperiment"))
    stopifnot("method must be either vst or rlog"= (method %in% c("vst", "rlog","normTransform")))
    warning("For length correction assayname must match with avgTxLength\n ")
    ## Should be checked
    # Need to convert to DESeqDataSet first from SummarizedExperiment object where
    # 'counts' assay should be the first in assays list
    if (SummarizedExperiment::assayNames(se)[1] != "counts") {
        nuOrder <-
            c("counts",
              setdiff(SummarizedExperiment::assayNames(se), "counts"))
        SummarizedExperiment::assays(se) <-
            SummarizedExperiment::assays(se)[nuOrder]
    }

    if (mode(assays(se)[["counts"]]) != "integer") {
        counts <- round(as.matrix(assays(se)[["counts"]]))
        mode(counts) <- "integer"
        assays(se)[["counts"]] <- counts
    }
    x <- DESeqDataSet(se, design = ~ 1)
    if (method == "rlog") {
        rd <- rlog(x,...)
    } else if(method == "vst"){
        rd <- varianceStabilizingTransformation(x, ...)
    }else if(method == "normTransform"){
        rd <- normTransform(x, ...)
    }
    assays(se)[[method]] <- assay(rd)
    return(se)
}

#' Plot clustered heatmaps
#'
#' Plot clustered heatmaps from SummarizedExperiment with pheatmap and return object as ggplot
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param scaledAssay an scaled assay name from SummarizedExperiment::assayNames(se)
#' @param ntop number of most-variable genes to select. Igored if "features" is specified.
#' @param features character vector features/genes to be used to measure distance between the samples
#' @param annotation_col a character vector of colnames of colData(se)
#' @param annotation_row a list of character vector of colnames of rowData(se)
#' @param show_geneAs a character vector of colnames of rowData(se)
#' @param ... other arguments like color or shape whose values should be similar
#' to colData columns names passed to \code{\link{pheatmap}}
#'
#' @return ggplot object
#' @export
#' @import pheatmap
#' @importFrom ggplotify as.ggplot
#' @importFrom dplyr select
#'
#' @examples
#' se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))
#'
#' se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
#'
#' broadSeq::plotHeatmapCluster(
#'     se,
#'     scaledAssay = "logCPM",
#'     annotation_col = c("species", "stage"),
#'     annotation_row = c("Class","gene_biotype"),
#'     ntop = 30, show_geneAs = "symbol",
#'     cluster_cols = TRUE, cluster_rows = FALSE,
#'     show_rownames = TRUE, show_colnames = FALSE,
#'     main = "Top 30 variable gene vst"
#' )
plotHeatmapCluster <- function(se, scaledAssay="vst", ntop = 500L,
                               features = NULL, show_geneAs = NULL,
                               annotation_col=NA, annotation_row=NA,...){
    stopifnot(is(se, "SummarizedExperiment"))
    stopifnot("scaledAssay must be an assay of se"= (scaledAssay %in% assayNames(se)))

    selected_genes <- getSelectedGene(features, se, ntop, scaledAssay)

    dottedArg <- list( ...)
    if(is.null(dottedArg$main) ) main = paste("Top ",length(selected_genes) ," variable genes")

    data_mat <- assays(se)[[scaledAssay]][selected_genes,]
    if(is.na2(annotation_col) == FALSE){
        stopifnot(
            "annotation_col must be a subset of colnames of colData(se)"= ((annotation_col %in% colnames(colData(se))))
        )
        df <- as.data.frame(colData(se)[,annotation_col])
        colnames(df) <- annotation_col
        rownames(df) <- colnames(se)
        annotation_col <- df
    }

    if(is.na2(annotation_row) == FALSE){
        stopifnot(
            "annotation_row must be a subset of colnames of rowData(se)"= ((annotation_row %in% colnames(rowData(se))))
        )
        df <- rowData(se)[selected_genes,] %>% as.data.frame()  %>%
            dplyr::select(all_of(annotation_row))
        colnames(df) <- annotation_row
        annotation_row <- df
    }

    if(!is.null(show_geneAs)){
        stopifnot(
            "show_geneAs must be a subset of colnames of rowData(se)"= ( (show_geneAs %in% colnames(rowData(se))))
        )
        gene_name <- as.data.frame(rowData(se)[selected_genes,])  %>% dplyr::select(all_of(show_geneAs))
        rownames(data_mat) <- gene_name[rownames(data_mat),]
        if(is.data.frame(annotation_row)){
             rownames(annotation_row) <- gene_name[rownames(annotation_row),]
        }
    }

    p<-pheatmap(data_mat, annotation_col=annotation_col,
                annotation_row=annotation_row,
                ...)
    return(as.ggplot(p))
}

#' Classical multidimensional scaling
#'
#' Classical multidimensional scaling is based on measuring the distance between the samples.
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param scaledAssay an scaled assay name from SummarizedExperiment::assayNames(se)
#' @param ntop number of most-variable genes to select. Igored if "features" is specified.
#' @param features character vector features/genes to be used to measure distance between the samples
#' @param ... other arguments like color or shape whose values should be similar
#' to colData columns names passed to ggpubr::\code{\link{ggscatter}}
#'
#' @return ggplot object
#' @export
#' @importFrom ggpubr ggscatter ggpar
#' @examples
#' se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))
#'
#' se <- broadSeq::transformDESeq2(se,method = "vst"  )
#'
#' broadSeq::plot_MDS(se, scaledAssay = "vst", ntop=500,
#'                     color = "species", shape = "stage",
#'                     ellipse=TRUE, legend = "bottom")
plot_MDS <- function(se, scaledAssay="vst", ntop = 500L, features = NULL,...){
    stopifnot(is(se, "SummarizedExperiment"))
    stopifnot("scaledAssay must be an assay of se"= (scaledAssay %in% assayNames(se)))

    selected_genes <- getSelectedGene(features, se, ntop, scaledAssay)

    # Get the data for those genes
    selected_expr <- assays(se)[[scaledAssay]][selected_genes, ]
    sampleDists <- dist( t( selected_expr ) )
    sampleDistMatrix <- as.matrix( sampleDists )
    mds <- data.frame(cmdscale(sampleDistMatrix))
    mds <- cbind(mds, colData(se))

    return(mds %>%
               ggscatter(x = "X1", y = "X2", ...) %>%
               ggpar(title = paste("Top ",length(selected_genes) ," variable genes"))
        )
}


#' Perform Principal Components Analysis
#'
#'
#' This function returns the results of stats::\code{\link{prcomp}} in a tidy list format.
#' This is more flexible for further custom PCA , biplot and exploring gene(factor) loading of the PCA.
#'
#' [Reused code](https://gist.github.com/tavareshugo/5ca8a5e18fedc3f23f5ec4b09a9fc906)
#'
#' @param se Object of \code{\link{SummarizedExperiment}} class
#' @param scaledAssay an scaled assay name from SummarizedExperiment::assayNames(se)
#' @param ntop number of most-variable genes to select. Igored if "features" is specified.
#' @param features character vector features/genes to be used for PCA
#' @param ... other arguments to be passed to stats::\code{\link{prcomp}}
#'
#' @return a list with four `data.frame` objects: pc_scores, eigen_values,
#' loadings (eigen vectors) and the original data.
#' @export
#' @importFrom dplyr %>%
#' @examples
#' se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))
#'
#' se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
#' computedPCA_logCPM <- broadSeq::prcompTidy(se, scaledAssay = "logCPM", ntop = 500)
#'
#' plotAnyPC(computedPCA = computedPCA_logCPM, x = 1, y = 2, color = "species",
#'          shape = "stage",legend = "bottom")
#' plotAnyPC(computedPCA = computedPCA_logCPM, x = 2, y = 3, color = "species",
#'          shape = "stage",legend = "bottom")
#'
#' computedPCA_logCPM$eigen_values %>%
#'  dplyr::filter(var_exp >= 0.5) %>% # Selecting PC explaining more than 1% variance
#'     ggbarplot(x="PC",y="var_exp", label = TRUE, label.pos = "out")
#'
prcompTidy <- function(se, scaledAssay="vst", ntop = 500L, features = NULL, ...){
    stopifnot(is(se, "SummarizedExperiment"))
    stopifnot("scaledAssay must be an assay of se"= (scaledAssay %in% assayNames(se)))
    stopifnot("features should be either NULL or subset of rownames"=
                  (is.null(features) | features %in% SummarizedExperiment::rownames(se)))

    selected_genes <- getSelectedGene(features, se, ntop, scaledAssay)

    # Get the data for those genes
    selected_expr <- assays(se)[[scaledAssay]][selected_genes, ]

    # perform a PCA on the data in assay(x) for the selected genes
    ## Need to transpose the matrix as prcomp clusters by rows
    pca <- prcomp(t(selected_expr), ...)

    # Get sample info
    sample_info <- as.data.frame(SummarizedExperiment::colData(se))

    #### Eigen scores table ####
    pc_scores <- sample_info %>%
        dplyr::bind_cols(as.data.frame(pca$x))

    #### Eigen values table ####
    eigen_values <- data.frame(PC = colnames(pca$x), stdev = pca$sdev) %>%
        dplyr::mutate(var = stdev^2,
                      var_pct = var/sum(var),
                      cum_var = cumsum(var_pct),
                      var_exp =round(var_pct,digits = 4) *100 , ## Variance Explained
                      PC = forcats::fct_inorder(PC))

    #### Factor loadings table ####
    factor_loadings <- pca$rotation %>%
        as.data.frame() %>%
        dplyr::mutate(gene = row.names(.)) %>%
        dplyr::select(gene, dplyr::everything())
    rownames(factor_loadings) <- factor_loadings$gene

    gene_info <- as.data.frame(SummarizedExperiment::rowData(se))

    factor_loadings <- purrr::reduce(lapply(list(factor_loadings,gene_info),
                              function(x) data.frame(x, rn = row.names(x))),
                       merge, all.x=TRUE)
    rownames(factor_loadings) <- factor_loadings$rn
    factor_loadings$rn <- NULL

    #### Convert the original data to a data.frame ####
    selected_expr <- selected_expr %>%
        as.data.frame() %>%
        dplyr::rename_all(dplyr::funs(paste0("sample", .))) %>%
        dplyr::mutate(gene = rownames(.)) %>%
        dplyr::select(gene, dplyr::everything())

    # Return a list with each of these xs
    return(list(pc_scores = pc_scores,
                eigen_values = eigen_values,
                loadings = factor_loadings,
                original = selected_expr))

}

#' @importFrom genefilter rowVars
getSelectedGene <- function(genes, se, ntop, scaledAssay) {
    if(!is.null(genes)){
        message("Only using ", length(genes), " genes as requested.")

        if(!all(genes %in% rownames(se))) stop("Not all provided genes are in the gene count matrix.")

        selected_genes <- genes # which(genes %in% rownames(se))
    } else if(is.numeric(ntop) & ntop < nrow(se)){
        ntop <- round(ntop)
        message("Only using ", ntop, " most variable genes.")

        # calculate the variance for each gene
        rv <- rowVars(assays(se)[[scaledAssay]])

        # select the ntop genes by variance
        selected_genes <- order(rv, decreasing=TRUE)[seq_len(min(ntop, length(rv)))]
    } else {
        message("Using all ", nrow(se), " genes.")
        selected_genes <- seq_len(nrow(se))
    }
    return(selected_genes)
}


#' Plots principal components
#'
#' @param computedPCA a list of data.frame returned by \code{\link{prcompTidy}}
#' @param x PC number for x-axis default 1
#' @param y PC number for y-axis default 2
#' @param ... other arguments like color or shape whose values should be similar
#' to colData columns names passed to ggpubr::\code{\link{ggscatter}}
#'
#' @return ggplot object
#' @export
#'
#' @importFrom ggpubr ggscatter ggpar
#' @importFrom ggplot2 scale_shape_manual
#' @rdname prcompTidy
plotAnyPC <- function(computedPCA,x =1 ,y = 2, ...){
    pc_x <- paste("PC",x,sep = "")
    pc_y <- paste("PC",y,sep = "")
    pct <- computedPCA$eigen_values %>%
        dplyr::filter(PC %in% c(pc_x,pc_y)) %>%
        dplyr::pull(var_pct) %>%
        round(digits = 4) *100
    dottedArg <- list( ...)

    p <- computedPCA$pc_scores %>% ggscatter(x = pc_x, y = pc_y,...)
    if(!is.null(dottedArg$shape) ) {
        computedPCA$pc_scores[,dottedArg$shape] <- factor(computedPCA$pc_scores[,dottedArg$shape])
        p <- p + scale_shape_manual(values=seq_len( 
          length(unique(computedPCA$pc_scores[,dottedArg$shape]))))
    }
    return(
        p %>%
            ggpar(title = paste(nrow(computedPCA$original) ," variable genes"),
                  xlab = paste(pc_x,pct[1]), ylab = paste(pc_y,pct[2]))
        )
}


#' biplotAnyPC
#'
#' @param computedPCA a list of data.frame returned by \code{\link{prcompTidy}}
#' @param genes if genes is NULL then top max and min loaded genes of each PCs are plotted
#' @param genesLabel one of rowData column names
#' @param ... other arguments like color or shape whose values should be similar
#' to colData columns names passed to ggpubr::\code{\link{ggscatter}}
#'
#' @return ggplot object
#' @export
#'
#' @examples
#' @importFrom ggpubr ggscatter ggpar
#' @importFrom ggplot2 geom_segment geom_text scale_shape_manual sym
#' @rdname prcompTidy
biplotAnyPC <- function(computedPCA,x = 1,y = 2,
                        genes=NULL, genesLabel = NULL,...){
    pc_x <- paste("PC",x,sep = "")
    pc_y <- paste("PC",y,sep = "")
    pct <- computedPCA$eigen_values %>%
        dplyr::filter(PC %in% c(pc_x,pc_y)) %>%
        dplyr::pull(var_pct) %>%
        round(digits = 4) *100
    dottedArg <- list( ...)

    p <- computedPCA$pc_scores %>% ggscatter(x = pc_x, y = pc_y,...)
    if(!is.null(dottedArg$shape) ) {
        computedPCA$pc_scores[,dottedArg$shape] <- factor(computedPCA$pc_scores[,dottedArg$shape])
        p <- p + scale_shape_manual(values=seq_len(computedPCA$pc_scores[,dottedArg$shape]))
    }

    if(is.null(genes)){
        pc1_genes <- computedPCA$loadings %>%
            filter(!!sym(pc_x) == max(!!sym(pc_x)) | !!sym(pc_x) == min(!!sym(pc_x))) %>% pull(gene)
        pc2_genes <- computedPCA$loadings %>%
            filter(!!sym(pc_y) == max(!!sym(pc_y)) | !!sym(pc_y) == min(!!sym(pc_y))) %>% pull(gene)
        genes <- c(pc1_genes,pc2_genes)
    }
    dA <- computedPCA$loadings[genes,] %>%
        dplyr::select(!!sym(pc_x),!!sym(pc_y), !!sym(genesLabel)) %>%
        dplyr::mutate_if( is.numeric, ~ . * 100)
    p <- p +
        geom_segment(data=dA, aes(x=0, y=0,xend=!!sym(pc_x), yend=!!sym(pc_y)), size = 1,
                     arrow=arrow(length=unit(0.2,"cm")), alpha=0.75, color="red")+
        geom_text(data=dA, aes(x=!!sym(pc_x), y=!!sym(pc_y),label= !!sym(genesLabel)),
                  size = 3, vjust=1, color="blue")
    return(
        p %>%
            ggpar(title = paste(nrow(computedPCA$original) ," variable genes"),
                  xlab = paste(pc_x,pct[1]), ylab = paste(pc_y,pct[2]))
        )
}

#' Useful for PCA
#'
#' @param computedPCA a list of data.frame returned by \code{\link{prcompTidy}}
#' @param pcs The numbers of PCs
#' @param topN Number of features per PC
#' @param keep the column names of rowData to keep the corresponding information
#'
#' @return a data.frame
#' @export
#'
#' @examples
#' @rdname prcompTidy
getFeatureLoadRanking <- function(computedPCA, pcs=seq_len(5), topN = 10, keep ){
    x <- plyr::ldply(paste("PC",pcs,sep = ""), .fun = extract_topGeneLoadings,
                loadings = computedPCA$loadings,
                topN = topN, keep = keep)
    x$PC <- x$PC %>% factor(levels =  paste("PC",seq_len(10),sep = ""))
    return(x)
}

extract_topGeneLoadings <- function(loadings,whichpc,topN,keep){
    geneloadings_sorted <- dplyr::arrange(loadings, desc(abs( !!sym(whichpc)))) %>%
        dplyr::select(all_of(keep), dplyr::all_of(whichpc))
    geneloadings_extreme <- geneloadings_sorted %>% dplyr::slice(seq_len(topN))#, with_ties = FALSE)
    colnames(geneloadings_extreme) <- c(dplyr::all_of(keep), "loading")
    geneloadings_extreme$PC <- whichpc
    geneloadings_extreme$Rank <- seq_len(topN)
    return(geneloadings_extreme)
}

---
title: "Using broadSeq to analyze RNA-seq data"
output: 
    BiocStyle::html_document:
        toc_float: true
vignette: >
  %\VignetteIndexEntry{Using broadSeq to analyze RNA-seq data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup, include = FALSE}
library(broadSeq)
```

# Introduction  

To analyze RNA-seq **count** data, there are several ways/methods for each steps
like

1.  Transforming/scaling of the count data,

2.  QC by clustering the samples using PCA, hierarchical clustering or 
multidimensional scaling

3.  Most importantly identification of differentially expressed.

For each of these steps, there are different packages or tools whose input and 
output formats are very different. Therefore it is very difficult to use all 
these features from different packages in a study.

```{r fig.cap = "Input and output data structures of different methods to idetify differentially expressed genes.", echo = FALSE}
knitr::include_graphics("img/io_p.png")
```

The *broadSeq* package simplifies the process of including many **Bioconductor** 
packages for RNA-seq data and evaluating their performance.

```{r echo = FALSE,fig.cap="Flowchart"}
knitr::include_graphics("img/broadSeq.png")
```

The silent features of *broadSeq* are

-   **Single input format** : `r Biocpkg("SummarizedExperiment")` 
-   **Single output format** : as base `data.frame`
-   Visualization : Using `ggplot2` and `ggpubr` packages for publication ready 
figures
-   Easy and advanced PCA analysis
-   Function oriented interface to include in existing pipeline.
-   Differential expression
    -   Comparison of different methods

# Reading the data

```{r eval = FALSE}
library(broadSeq)
library(ggplot2)
```

Here we read gene expression data which is quantified by `salmon` and
processed by `r Biocpkg("tximport")` package. The `salmon` generates count data,
"abundance" (TPM) and gene length values. Therefore we may rename the corresponding
assay slot 'abundance' to 'TPM'.

These data belongs to this studies reference!!

In this data, there are gene expression values from first molar tissue
of three different developing rodent species. The tissues are also from
four different developmental time points.

```{r message=FALSE}
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))
SummarizedExperiment::assayNames(se)
```

## Sample metadata

```{r }
as.data.frame(colData(se)) %>% dplyr::count(stage,species) %>% tidyr::spread(stage,n)

se$stage <- factor(se$stage,levels = c("Bud","Cap","Late Cap","Bell"))
```

## Filtering out low expression genes

```{r lowExpr,warning=FALSE,fig.width= 6}
assays(se)[["counts"]][,5] %>% ggpubr::ggdensity(y = "count")+
    ggplot2::geom_vline(xintercept = 10)+ggplot2::scale_x_log10()

keep <- (assays(se)[["counts"]] >= 3) %>% rowSums() >= 5 
# smallest Group Size is 5
table(keep)
```

# Normalization

`r Biocpkg("edgeR")` provides two different methods ; CPM and TMM. But it does not use
normalized values for Differential Expression.

It also does not normalizes count values rather it normalizes the
library sizes using "TMM" method in 'normLibSizes'. Either use or not
use normLibSizes(). edgeR::cpm() will generate normalized expression
values.

## CPM

```{r warning=FALSE,message=FALSE}
se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
## The normalized values are added with the assay name "logCPM"
SummarizedExperiment::assayNames(se)
```

## TMM

```{r warning=FALSE,message=FALSE}
se <- broadSeq::normalizeEdgerCPM(se , method = "TMM", cpm.log = FALSE )
## The normalized values are added with the assay name "TMM"
SummarizedExperiment::assayNames(se)
```

## access

```{r }
assays(se)[["counts"]][1:5,1:5]
assays(se)[["TMM"]][1:5,1:5]
assays(se)[["logCPM"]][1:5,1:5]
```

# Transformation

`r Biocpkg("DESeq2")` provides three different transformations

## VST

variance stabilizing transformation (VST)

```{r warning=FALSE}
se <- broadSeq::transformDESeq2(se,method = "vst"  )
```

## Normalized counts transformation

```{r }
se <- broadSeq::transformDESeq2(se, method = "normTransform"  )
```

## rlog

regularized log

```{r eval=FALSE}
se <- broadSeq::transformDESeq2(se, method = "rlog")
```

```{r }
SummarizedExperiment::assayNames(se)
```

## Comparision

Boxplot of different transforms for each sample.

```{r warning=FALSE,fig.height=6,fig.width=8}
p <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse" ], 
                           assayName = "counts", fill = "stage", 
                           yscale = "log2")+ rremove("x.text")

p1 <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse"], 
                           assayName = "vst", fill = "stage")+ rremove("x.text")

p2 <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse"], 
                           assayName = "TMM", fill = "stage", 
                           yscale = "log10")+ rremove("x.text")

p3 <- broadSeq::sampleAssay_plot(se[, se$species=="Mouse"], 
                           assayName = "logCPM", fill = "stage")+ rremove("x.text")


ggarrange(p,p1,p2,p3, common.legend = TRUE, labels = c("A","B","C"))
```

Plot standard deviations versus means expression

```{r eval=FALSE}
if (requireNamespace("vsn", quietly = TRUE)) {
    library("vsn")
    x <- meanSdPlot(
        log2(assays(se[, se$species == "Rat"])[["counts"]]+1),
        plot = FALSE)
    print(x$gg +ggtitle(label = "log2(n+1) "))
    
    x <- meanSdPlot(
        assays(se[, se$species == "Rat"])[["vst"]],
        plot = FALSE)
    
    print(x$gg +ggtitle(label = "Vst"))
    
    x <- meanSdPlot(
        assays(se[, se$species == "Rat"])[["logCPM"]],
        plot = FALSE)
    print(x$gg + ggtitle(label = "logCPM"))
}    

```

# Visualization of gene Expression

```{r message=FALSE,warning=FALSE}
## Multiple assay of a single gene
broadSeq::assay_plot(se, feature = c("Shh"), 
           assayNames = c("counts","logCPM","vst","TMM"),
           x = "stage", fill="species", add="dotplot", palette = "npg")

## Expression of multiple genes from a single assay
broadSeq::genes_plot(se, 
                     features = c("Shh","Edar"), 
                     facet.by = "symbol",
                     x = "stage", assayName = "vst", color="species", palette = "jco")
```

## Pre-defined or custom color palette based on journals

Scientific journal palettes from `ggsci` R package, e.g.: "npg", "aaas",
"lancet", "jco", "ucscgb", "uchicago", "simpsons" and "rickandmorty" can
be passed for coloring or filling by groups from metadata.

```{r warning=FALSE,message=FALSE,fig.height=6,fig.width=8}
jco <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol", assayName =  "logCPM",
                     x = "stage",  fill="stage", add="dotplot", xlab = "", 
                     add.params = list(size= 0.5), 
                     caption = "Journal of Clinical Oncology", palette = "jco") 

npg <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol",assayName =  "logCPM",
                     x = "stage", fill="stage", add="dotplot", xlab = "", 
                     add.params = list(size= 0.5),
                     caption = "Nature Publishing Group", palette = "npg") 

aaas <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol", assayName = "logCPM",
                     x = "stage", fill="stage", add="dotplot", xlab = "", 
                     add.params = list(size= 0.5),
                     caption = "Science", palette = "aaas")

nejm <- broadSeq::genes_plot(se[,se$species == "Mouse"], 
                     features = c("Shh"), facet.by = "symbol", assayName = "logCPM",
                     x = "stage", color="stage", add="dotplot",  xlab = "", 
                     add.params = list(size= 0.5),
                     caption = "New England \nJournal of Medicine",palette = "nejm")

# ggarrange(jco,npg,aaas,nejm, 
#           common.legend = TRUE,legend = "none",
#           labels = c("A","B","C","D"))

ggarrange(jco+ggpubr::rotate_x_text(), npg+ggpubr::rotate_x_text(),
          aaas+ggpubr::rotate_x_text(),nejm+ggpubr::rotate_x_text(),
          nrow = 1, common.legend = TRUE,legend = "none",
          labels = c("A","B","C","D")) %>% 
    annotate_figure( top = text_grob("Color palette")) 
```

# QC with Clustering

## MDS plot

Classical multidimensional scaling is based on measuring the distance
between the samples.

Popular function plotMDS from `r Biocpkg("limma")` does not work with
`r Biocpkg("SummarizedExperiment")` object. Here broadSeq provides this function
through package `cmdscale {stats}`.

```{r fig.height=6,fig.width=8}
broadSeq::plot_MDS(se, scaledAssay = "vst", ntop=500, 
                   color = "species", shape = "stage", 
                   ellipse=TRUE, legend = "bottom")
```

MDS is cool but it is not possible to know/visualize top variable genes
with their meta data which is stored in `se` object

```{r }
head(rowData(se))
```

Other methods can help to visualize gene information along with
clustering information.

## Hierarchical clustering and Heatmap

```{r fig.height=6,fig.width=8}
p_vst <- broadSeq::plotHeatmapCluster(
    se,
    scaledAssay = "vst",
    annotation_col = c("species", "stage"),
    annotation_row = c("Class","gene_biotype"),
    ntop = 30, show_geneAs = "symbol",
    cluster_cols = TRUE, cluster_rows = FALSE,
    show_rownames = TRUE, show_colnames = FALSE,
    main = "Top 30 variable gene vst"
)
```

## PCA plot

### prcompTidy

Perform Principal Components Analysis with function
`broadSeq::prcompTidy()` which returns a list of four `data.frame`
objects:

-   pc_scores,

-   eigen_values,

-   loadings (eigen vectors) and

-   the original data.

    Compute PCA using any assay

```{r warning=FALSE}
computedPCA_logCPM <- broadSeq::prcompTidy(se, scaledAssay = "logCPM", ntop = 500)
## PCA based on vst values
computedPCA_vst <- broadSeq::prcompTidy(se, scaledAssay = "vst", ntop = 500)
```

### Plot

#### logCPM

```{r fig.width=8,fig.height=6}
plotAnyPC(computedPCA = computedPCA_logCPM,
          x = 1, y = 2, color = "species", shape = "stage",
          legend = "bottom")
```

#### VST

Here PC 2 and 3 are used which can cluster the samples by both species and developmental
factors. 
```{r fig.width=8,fig.height=6}
pca_vst <- plotAnyPC(computedPCA = computedPCA_vst,
            x = 2, y = 3,  color = "species", shape = "stage", 
            legend = "bottom") 
```

#### Other PCs

```{r fig.width=8,fig.height=6}
computedPCA_vst$eigen_values %>%
        dplyr::filter(var_exp >= 2) %>%
    ggbarplot(x="PC",y="var_exp", label = TRUE, label.pos = "out")
```

It can be checked if there are other PCs to explain considerable
variance. PC3 can be useful to see variance due to different
developmental time points.

```{r fig.width=8,fig.height=6}
pca_vst_2_3 <-plotAnyPC(computedPCA = computedPCA_vst,
                x = 2, y = 3,  
                color = "species", shape = "stage", legend = "bottom")
# pca_vst_2_3
```

PC3 captures beautifully the variance in gene expression due to
developmental stages.
<!-- The PCAs are different since the top 500 genes are different for rlog and vst.   -->

#### Gene loading

```{r fig.width=7,fig.height=6}
computedPCA_vst %>% broadSeq::getFeatureLoadRanking(keep = c("symbol","Class")) %>% head()

#  Top 5 genes of PC2

computedPCA_vst$loadings %>% top_n(5,abs(PC2)  ) %>% dplyr::select(gene,PC2)

pca_vst_loading <- computedPCA_vst %>% 
    broadSeq::getFeatureLoadRanking(keep = c("symbol","Class"), topN = 50, pcs=1:10) %>% 
    dplyr::count(Class, PC) %>%
    ggbarplot(
        x = "PC", y = "n", fill = "Class",
        legend = "bottom", palette = c("red","blue","orange","purple","white","grey")
    ) 
# pca_vst_loading
```

#### Biplot

```{r fig.width=8,fig.height=6}
# By default it plots top 2 genes from each PC axis
pca_vst_bi <- broadSeq::biplotAnyPC(computedPCA = computedPCA_vst, 
            x = 1, y = 2, genesLabel = "symbol", 
            color = "species", shape = "stage", 
            legend = "bottom")
# pca_vst_bi
```


```{r fig.width=8,fig.height=8}
ggarrange(
    ggarrange(pca_vst_bi+ggtitle(label =  ""),
          pca_vst_2_3+ggtitle(label =  ""), common.legend = TRUE),
    pca_vst_loading, nrow = 2)

```

#### User defined genes

Now plotting top 5 genes from PC3

```{r fig.width=8,fig.height=6}
# Top 5 genes of PC3
biplotAnyPC(computedPCA = computedPCA_vst,x = 2, y = 3, 
            color = "species", shape = "stage",
            genes= computedPCA_vst$loadings %>% 
                top_n(5,abs(PC3)) %>% pull(gene),
            genesLabel = "symbol")

## Plot progression gene "Shh" 
biplotAnyPC(computedPCA = computedPCA_vst,x = 2, y = 3, 
            color = "species", shape = "stage",
            genes=c("Shh"),
            genesLabel = "symbol")
```


# Compare Differential expression 

## Data 

In this example we will use RNA-seq expression data from developing mouse molar tissue. First we read the data as a `SummarizedExperiment` object. 

```{r warning=FALSE,eval=TRUE}
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))

# To reduce the run time, subset of the data used here
se <- se[,colData(se)$species == "Mouse"]
```


```{r warning=FALSE,eval=FALSE,echo=FALSE}
count_matrix <- as.matrix(read.table(file = system.file("extdata", 
                                              "tooth_RNASeq_counts.txt", 
                                              package = "DELocal")))
colData <- data.frame(condition=gsub("\\..*",x=colnames(count_matrix),replacement = ""))

gene_location <- read.table(file = system.file("extdata", 
                                              "gene_location.txt", 
                                              package = "DELocal"))

se <- SummarizedExperiment::SummarizedExperiment(assays=list(counts=count_matrix),
                                                      rowData = gene_location, 
                                                      colData=colData)
# contrast= c("condition","ME13","ME14")
```

### Gene information

```{r warning=FALSE}
head(rownames(se))
head(rowData(se))
```

### Sample information  

The sample metadata  

```{r warning=FALSE,eval=TRUE}
head(colData(se))
table(colData(se)$stage)
```
<!-- There are two biological conditions ME13 and ME14 (embryonic days 13 and 14) with seven replicates each. The relevant question is which genes are differentially expressed between these two developmental time points. -->

## Differential Expression  

There are four developmental time points; Bud, Cap, Late Cap and Bell (from embryonic days 13 to 16) with seven replicates each. Here, in this example, DE genes between Bud and Cap stages will be identified.

### Function pattern  

In broadSeq, the names of DE method has similar pattern like "use_"+"method name". All these method has same signature of input arguments. 

Here we will see `use_NOIseq()` method to apply `NOISeq::noiseqbio()` function.   

```{r warning=FALSE,fig.width=6,fig.height=6,message=FALSE}
result_Noiseq <- 
    use_NOIseq(se = se, 
           colData_id = "stage", control = "Bud", treatment = "Cap",
           rank = TRUE, 
           r = 10) # r is an argument of NOISeq::noiseqbio

head(result_Noiseq)
```



```{r warning=FALSE,fig.width=8,fig.height=6,message=FALSE}
pg <- broadSeq::genes_plot(se, x = "stage", assayName =  "counts",  
           features = result_Noiseq %>% dplyr::filter(rank <5) %>% rownames(),
           fill="stage", facet.by = "symbol",
           palette="jco", add = "dotplot") +rotate_x_text()

pg_sc <- ggscatter(result_Noiseq, x="Bud_mean", y="Cap_mean",color = "prob")+ 
    scale_x_log10()+scale_y_log10()

pg+pg_sc
```

<!-- Note that the results="hide" and fig.keep = "none" parameters were added to the code chunk to prevent printing of the R code results and the exploratory plots created in the code chunk. -->

### Available methods

Following implementations of popular methods are available here.
```{r warning=FALSE,results="hide", fig.keep = "none"}
# limma 
?use_limma_trend(se, colData_id, control, treatment, rank = FALSE, ...)
?use_limma_voom(se, colData_id, control, treatment, rank = FALSE, ...)

# edgeR 
?use_edgeR_exact(se, colData_id, control, treatment, rank = FALSE, ...)
?use_edgeR_GLM(se, colData_id, control, treatment, rank = FALSE, ...)

# deseq2
?use_deseq2(se, colData_id, control, treatment, rank = FALSE, ...)

# DELocal
?use_DELocal(se, colData_id, control, treatment, rank = FALSE, ...)

# noiseq
?use_NOIseq(se, colData_id, control, treatment, rank = FALSE, ...) 

# EBSeq 
?use_EBSeq(se, colData_id, control, treatment, rank = FALSE, ...)

# samseq
?use_SAMseq(se, colData_id, control, treatment, rank = FALSE, ...)
```

Advanced users can pass package specific arguments through '...' .

## Compare DE results

It is possible to execute all DE methods together and get aggregated results in a data.frame.
`broadSeq::use_multDE()` should be used for it.

```{r warning=FALSE,results="hide", fig.keep = "none"}
# First define a named list of functions
funs <- list(limma_trend = use_limma_trend, limma_voom = use_limma_voom,
             edgeR_exact = use_edgeR_exact, edgeR_glm = use_edgeR_GLM,
             deseq2 = use_deseq2, 
             DELocal = use_DELocal, noiseq = use_NOIseq, 
             EBSeq = use_EBSeq) 


multi_result <- broadSeq::use_multDE(
    se = se, 
    deFun_list = funs, return.df = TRUE,  
    colData_id = "stage", control = "Bud", treatment = "Cap", 
    rank = TRUE)
```

The column names of the resultant data.frame are prefixed with corresponding function names. 

```{r warning=FALSE}
head(multi_result)
# nrow(multi_result) == nrow(se)
colnames(multi_result)
```

#### Similarity of methods

DE methods are clustered based on their ranking of genes

```{r warning=FALSE,fig.width=6,fig.height=6,eval=TRUE}
clusters <- multi_result %>% dplyr::select(ends_with("rank")) %>% t() %>% dist() %>% hclust()
plot(clusters,main =  "distance: Euclidean")
```

### Plots

#### Volcano 

Up regulated genes should be red or hot colors  

```{r warning=FALSE,fig.width=6,fig.height=6,eval=TRUE}
multi_result %>% broadSeq::volcanoPlot(
    pValName = "deseq2_padj",
    lFCName = "deseq2_log2FoldChange",
    labelName = "symbol",
    palette = "lancet" ,
    selectedLabel =
        multi_result %>% dplyr::arrange(deseq2_padj) %>% pull(symbol) %>% head()
)

multi_result %>% broadSeq::volcanoPlot(
    pValName = "deseq2_padj",
    lFCName = "deseq2_log2FoldChange",
    labelName = "symbol",
    palette = c("purple","orange","grey"),
    selectedLabel = list(criteria = "(`x` > 5 | `x` < -2) & (`y` > 10)")
) +xlim(-7.5,7.5)
```

Annotating the genes in the volcano plot.
```{r warning=FALSE,fig.width=6,fig.height=6,eval=TRUE}
multi_result %>% broadSeq::volcanoPlot(
    pValName = "deseq2_padj",
    lFCName = "deseq2_log2FoldChange",
    labelName = "symbol",
    color = "Class",
    palette = "lancet",
    selectedLabel = list(criteria = "(Class %in% c('Progression','Shape')) & (`y` > 10)")
) +xlim(-7.5,7.5)
```


<details>
<summary>Session Info</summary>

```{r warning=FALSE,error=FALSE}
sessionInfo()
```

</details>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{combinedEnrichment}
\alias{combinedEnrichment}
\title{Provides GO gene set enrichment and over-representation analysis}
\usage{
combinedEnrichment(
  DEG_table,
  geneCol = "ID",
  logCol = "logFoldChange",
  OrgDB = "org.Hs.eg.db",
  keyType,
  universe,
  ont = "BP",
  logfoldCut = 1,
  pvalueCutoff = 0.05,
  qvalueCutoff = 0.05
)
}
\arguments{
\item{DEG_table}{A data.frame atleast with two columns.}

\item{geneCol}{The column name of DEG_table which provides gene ids and should
be compatible with keytype parameter.}

\item{logCol}{The column name of DEG_table which provides logfold(numeric) values to
create a order ranked geneList for gseGO funtion.}

\item{OrgDB}{OrgDb; passed to clusterProfiler functions}

\item{keyType}{keytype of input gene(geneCol). One of the keytypes(OrgDB); passed to clusterProfiler functions}

\item{universe}{background genes; passed to clusterProfiler::enrichGO.}

\item{ont}{one of "BP", "MF", and "CC" subontologies, or "ALL" for all three.; passed to clusterProfiler functions}

\item{logfoldCut}{to filter genes based on parameter logCol}

\item{pvalueCutoff}{; passed to clusterProfiler functions}

\item{qvalueCutoff}{; passed to clusterProfiler functions}
}
\value{
a named list of three data.frames which are output of gseGO("gseResult")
and enrichGO ("oraUP" and "oraDOWN").
}
\description{
This wrapper function combines clusterProfiler::gseGO and
clusterProfiler::enrichGO. The input type of thes two methods are different;
order ranked geneList and a vector of entrez gene id. Here combinedEnrichment
function internally generates these two data types from user defined DEG_table
(differentially expresssed genes).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{use_NOIseq}
\alias{use_NOIseq}
\title{Differential expression method for NOISeq}
\usage{
use_NOIseq(se, colData_id, control, treatment, rank = FALSE, ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{colData_id}{One of the columns of colData(se). It should be factors of more than one value.}

\item{control}{Base level and one of the factor values of \code{colData(se)[[colData_id]]}}

\item{treatment}{one of the factor values of \code{colData(se)[[colData_id]]}}

\item{rank}{Logical value default FALSE. If true the result will have an
additional column named "rank" which is ordered by ´prob´ values returned by
function NOISeq::\code{\link{noiseqbio}}.}

\item{...}{other arguments to be passed to main function NOISeq::\code{\link{noiseqbio}}.
The 'input' and 'factor' argument should not be used.}
}
\value{
A data.frame object from the results of NOISeq::noiseqbio(). For details check
the documentation of ´NOISeq´
}
\description{
This is a wrapper function of NOISeq::\code{\link{noiseqbio}} whose input class is ´eSet´
and output class is \code{Output} which are not widely used. We can use as(se, "ExpressionSet")
to get an eSet easily but then it will be hard to refer the treatment and control.
The order of factors influence the log fold change sign. To keep it comparable
to other methods the \code{NOISeq::readData()} is used internally.
}
\examples{

se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

# To reduce runtime
se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]

result_Noiseq <-
    use_NOIseq(se = se,
           colData_id = "stage", control = "Bud", treatment = "Cap",
           rank = TRUE,
           r = 10) # r is an argument of NOISeq::noiseqbio
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusteringVisualization.R
\name{plot_MDS}
\alias{plot_MDS}
\title{Classical multidimensional scaling}
\usage{
plot_MDS(se, scaledAssay = "vst", ntop = 500L, features = NULL, ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{scaledAssay}{an scaled assay name from SummarizedExperiment::assayNames(se)}

\item{ntop}{number of most-variable genes to select. Igored if "features" is specified.}

\item{features}{character vector features/genes to be used to measure distance between the samples}

\item{...}{other arguments like color or shape whose values should be similar
to colData columns names passed to ggpubr::\code{\link{ggscatter}}}
}
\value{
ggplot object
}
\description{
Classical multidimensional scaling is based on measuring the distance between the samples.
}
\examples{
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))

se <- broadSeq::transformDESeq2(se,method = "vst"  )

broadSeq::plot_MDS(se, scaledAssay = "vst", ntop=500,
                    color = "species", shape = "stage",
                    ellipse=TRUE, legend = "bottom")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{use_EBSeq}
\alias{use_EBSeq}
\title{To use SummarizedExperiment with package EBSeq}
\usage{
use_EBSeq(se, colData_id, control, treatment, rank = FALSE, ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{colData_id}{One of the columns of colData(se). It should be factors of
more than one value.}

\item{control}{Base level and one of the factor values of \code{colData(se)[[colData_id]]}}

\item{treatment}{one of the factor values of \code{colData(se)[[colData_id]]}}

\item{rank}{Logical value default FALSE. If true the result will have an
additional column named "rank" and the results are ranked on "PPDE"}

\item{...}{other arguments to be passed to main function EBSeq::\code{\link{GetDEResults}}.}
}
\value{
a data.frame object converted from the output of EBSeq::\code{\link{GetDEResults}}.
}
\description{
A wrapper function of EBSeq where input is an object of \code{\link{SummarizedExperiment}}
}
\examples{

se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

# To reduce runtime
se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]

result <-
    use_EBSeq(se = se,
           colData_id = "stage", control = "Bud", treatment = "Cap",
           rank = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalize.R
\name{transformDESeq2}
\alias{transformDESeq2}
\title{Transform SummarizedExperiment with DESeq2 package}
\usage{
transformDESeq2(se, method = "vst", ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{method}{"vst", "normTransform" or "rlog" to choose either of DESeq2::\code{\link{varianceStabilizingTransformation}}
DESeq2::\code{\link{normTransform}} and DESeq2::\code{\link{rlog}} function.
default is "vst"}

\item{...}{arguments passed to \code{\link{varianceStabilizingTransformation}}
\code{\link{normTransform}} and \code{\link{rlog}}}
}
\value{
Object of \code{\link{SummarizedExperiment}} class where a new assay
is added to the input object.
}
\description{
To use SummarizedExperiment with DESeq2, this function makes sure that 'counts'
assay should be the first in assays list and the mode is integer.
}
\examples{
 se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

se <- broadSeq::transformDESeq2(se,method = "vst"  )
# The transformed values are added with the assay name "vst"
SummarizedExperiment::assayNames(se)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{genes_plot}
\alias{genes_plot}
\alias{assay_plot}
\title{Expression of multiple genes/features from a single assay as boxplot (or added dotplot)}
\usage{
genes_plot(se, features, assayName = "counts", facet.by = "feature", x, ...)

assay_plot(se, feature, assayNames = c("counts"), x, ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{features}{a character vector of rownames or named list of character vectors
where name is one of the colnames of rowdata.}

\item{assayName}{One of the values from SummarizedExperiment::assayNames(se);
default is "counts" assay}

\item{facet.by}{must be one of the column names of rowData(se). default
"feature" which is equivalent to rownames of rowData}

\item{x}{a column name of colData which will be used in x-axis}

\item{...}{other arguments to be passed to ggpubr::\code{\link{ggboxplot}}}

\item{feature}{a character vector of rownames or named list of character vectors
where name is one of the column of rowdata.}

\item{assayNames}{names from SummarizedExperiment::assayNames(se); default
value is "counts"}
}
\value{
ggplot object

return an object of class ggarrange, which is a ggplot or a list of ggplot.
}
\description{
Expression of multiple genes/features from a single assay as boxplot (or added dotplot)

Boxplot of a single gene/feature from multiple assays
}
\examples{
se <- readRDS(system.file("extdata", "rat_vole_mouseSE_salmon.rds",
    package = "broadSeq"))
# The normalized values are added with the assay name "logCPM"
se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )

broadSeq::genes_plot(se,
                     features = list(mouse_gene_id = c("ENSMUSG00000022510" ,
                                                        "ENSMUSG00000027985")),
                     facet.by = "symbol", # column of rowData
                     x = "stage",  fill="stage")

broadSeq::genes_plot(se,
                     features = list(symbol=c("Shh","Edar") ),
                     facet.by = "symbol", # column of rowData
                     x = "stage",  fill="stage")

broadSeq::assay_plot(se, feature = c("Shh"),
                    assays =  c("counts","logCPM"),
                    x = "stage", fill="stage", add="dotplot", palette = "npg")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusteringVisualization.R
\name{prcompTidy}
\alias{prcompTidy}
\alias{plotAnyPC}
\alias{biplotAnyPC}
\alias{getFeatureLoadRanking}
\title{Perform Principal Components Analysis}
\usage{
prcompTidy(se, scaledAssay = "vst", ntop = 500L, features = NULL, ...)

plotAnyPC(computedPCA, x = 1, y = 2, ...)

biplotAnyPC(computedPCA, x = 1, y = 2, genes = NULL, genesLabel = NULL, ...)

getFeatureLoadRanking(computedPCA, pcs = seq_len(5), topN = 10, keep)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{scaledAssay}{an scaled assay name from SummarizedExperiment::assayNames(se)}

\item{ntop}{number of most-variable genes to select. Igored if "features" is specified.}

\item{features}{character vector features/genes to be used for PCA}

\item{...}{other arguments like color or shape whose values should be similar
to colData columns names passed to ggpubr::\code{\link{ggscatter}}}

\item{computedPCA}{a list of data.frame returned by \code{\link{prcompTidy}}}

\item{x}{PC number for x-axis default 1}

\item{y}{PC number for y-axis default 2}

\item{genes}{if genes is NULL then top max and min loaded genes of each PCs are plotted}

\item{genesLabel}{one of rowData column names}

\item{pcs}{The numbers of PCs}

\item{topN}{Number of features per PC}

\item{keep}{the column names of rowData to keep the corresponding information}
}
\value{
a list with four \code{data.frame} objects: pc_scores, eigen_values,
loadings (eigen vectors) and the original data.

ggplot object

ggplot object

a data.frame
}
\description{
This function returns the results of stats::\code{\link{prcomp}} in a tidy list format.
This is more flexible for further custom PCA , biplot and exploring gene(factor) loading of the PCA.
}
\details{
\href{https://gist.github.com/tavareshugo/5ca8a5e18fedc3f23f5ec4b09a9fc906}{Reused code}
}
\examples{
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))

se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )
computedPCA_logCPM <- broadSeq::prcompTidy(se, scaledAssay = "logCPM", ntop = 500)

plotAnyPC(computedPCA = computedPCA_logCPM, x = 1, y = 2, color = "species",
         shape = "stage",legend = "bottom")
plotAnyPC(computedPCA = computedPCA_logCPM, x = 2, y = 3, color = "species",
         shape = "stage",legend = "bottom")

computedPCA_logCPM$eigen_values \%>\%
 dplyr::filter(var_exp >= 0.5) \%>\% # Selecting PC explaining more than 1\% variance
    ggbarplot(x="PC",y="var_exp", label = TRUE, label.pos = "out")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{sampleAssay_plot}
\alias{sampleAssay_plot}
\title{Useful to visualize distribution of assay values for each sample. Plots 'boxplot'
of any assay for each sample. Aesthetic can be added from colData.}
\usage{
sampleAssay_plot(se, assayName = "counts", ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{assayName}{One of the values from SummarizedExperiment::assayNames(se)}

\item{...}{other arguments to be passed to ggpubr::\code{\link{ggboxplot}}}
}
\value{
ggplot object
}
\description{
Useful to visualize distribution of assay values for each sample. Plots 'boxplot'
of any assay for each sample. Aesthetic can be added from colData.
}
\examples{
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))

sampleAssay_plot(se, assayName = "counts",
fill="stage", # stage is a column name of colData(se)
yscale="log2")

se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )

sampleAssay_plot(se, assayName = "logCPM", fill="stage")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{use_limma_trend}
\alias{use_limma_trend}
\alias{use_limma_voom}
\alias{use_limma}
\title{To use SummarizedExperiment with package limma}
\usage{
use_limma_trend(se, colData_id, control, treatment, rank = FALSE, ...)

use_limma_voom(se, colData_id, control, treatment, rank = FALSE, ...)

use_limma(
  se,
  colData_id,
  control,
  treatment,
  rank = FALSE,
  useVoom = TRUE,
  showPlot = FALSE,
  limma.adjust = "BH",
  limma.sort.by = "p",
  limma.number = Inf,
  ...
)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{colData_id}{One of the columns of colData(se). It should be factors of more than one value.}

\item{control}{Base level and one of the factor values of \code{colData(se)[[colData_id]]}}

\item{treatment}{one of the factor values of \code{colData(se)[[colData_id]]}}

\item{rank}{Logical value default FALSE. If true the result will have an
additional column named "rank"}

\item{...}{other arguments to be passed to main function edgeR::calcNormFactors .}

\item{useVoom}{whether to use limma::voom or edgeR::cpm}

\item{showPlot}{whether to use limma::plotSA ; default FALSE}

\item{limma.adjust}{argument for limma::topTable}

\item{limma.sort.by}{argument for limma::topTable}

\item{limma.number}{argument for limma::topTable}
}
\value{
a data.frame of output from limma::topTable
}
\description{
A wrapper function of limma where input is an object of \code{\link{SummarizedExperiment}}
}
\examples{

se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

# To reduce runtime
se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]
result <-
    use_limma(se = se,
           colData_id = "stage", control = "Bud", treatment = "Cap",
           rank = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/broadSeq-package.R
\docType{package}
\name{broadSeq-package}
\alias{broadSeq}
\alias{broadSeq-package}
\title{broadSeq : for streamlined exploration of RNA-seq data}
\description{
This package helps user to do easily RNA-seq data analysis with multiple methods (usually which needs many different input formats). Here the user will provid the expression data as a SummarizedExperiment object and will get results from different methods. It will help user to quickly evaluate different methods.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/dasroy/broadSeq}
  \item Report bugs at \url{https://github.com/dasroy/broadSeq/issues}
}

}
\author{
\strong{Maintainer}: Rishi Das Roy \email{rishi.dasroy@gmail.com} (\href{https://orcid.org/0000-0002-3276-7279}{ORCID})

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalize.R
\name{normalizeEdgerCPM}
\alias{normalizeEdgerCPM}
\title{Use of edgeR package to normalize count data}
\usage{
normalizeEdgerCPM(se, method = "TMM", cpm.log = TRUE, ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{method}{value for edgeR::\code{\link{normLibSizes}} function. default "TMM"}

\item{cpm.log}{value for edgeR::\code{\link{cpm}} function. default TRUE}

\item{...}{passed to normLibSizes function}
}
\value{
Object of \code{\link{SummarizedExperiment}} class where a new assay
is added to the input object.
}
\description{
Use of edgeR package to normalize count data
}
\examples{
se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

se <- broadSeq::normalizeEdgerCPM(se , method = "TMM", cpm.log = FALSE )
# The normalized values are added with the assay name "TMM"
SummarizedExperiment::assayNames(se)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{round_df}
\alias{round_df}
\title{Applies round function only on numeric columns of a data.frame.}
\usage{
round_df(df, digits)
}
\arguments{
\item{df}{data.frame object}

\item{digits}{passed to \code{\link{round}}}
}
\value{
data.frame object
}
\description{
Applies round function only on numeric columns of a data.frame.
}
\examples{
data("iris")
iris \%>\% round_df(digits = 0) \%>\% head()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusteringVisualization.R
\name{plotHeatmapCluster}
\alias{plotHeatmapCluster}
\title{Plot clustered heatmaps}
\usage{
plotHeatmapCluster(
  se,
  scaledAssay = "vst",
  ntop = 500L,
  features = NULL,
  show_geneAs = NULL,
  annotation_col = NA,
  annotation_row = NA,
  ...
)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{scaledAssay}{an scaled assay name from SummarizedExperiment::assayNames(se)}

\item{ntop}{number of most-variable genes to select. Igored if "features" is specified.}

\item{features}{character vector features/genes to be used to measure distance between the samples}

\item{show_geneAs}{a character vector of colnames of rowData(se)}

\item{annotation_col}{a character vector of colnames of colData(se)}

\item{annotation_row}{a list of character vector of colnames of rowData(se)}

\item{...}{other arguments like color or shape whose values should be similar
to colData columns names passed to \code{\link{pheatmap}}}
}
\value{
ggplot object
}
\description{
Plot clustered heatmaps from SummarizedExperiment with pheatmap and return object as ggplot
}
\examples{
se <- readRDS(system.file("extdata","rat_vole_mouseSE_salmon.rds", package = "broadSeq"))

se <- broadSeq::normalizeEdgerCPM(se ,method = "none",cpm.log = TRUE )

broadSeq::plotHeatmapCluster(
    se,
    scaledAssay = "logCPM",
    annotation_col = c("species", "stage"),
    annotation_row = c("Class","gene_biotype"),
    ntop = 30, show_geneAs = "symbol",
    cluster_cols = TRUE, cluster_rows = FALSE,
    show_rownames = TRUE, show_colnames = FALSE,
    main = "Top 30 variable gene vst"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{use_multDE}
\alias{use_multDE}
\title{To identify differentially expressed genes by multiple methods}
\usage{
use_multDE(
  deFun_list,
  return.df = FALSE,
  se,
  colData_id,
  control,
  treatment,
  ...
)
}
\arguments{
\item{deFun_list}{a list of function which can perform differential expression analysis}

\item{return.df}{whether to return all results aggregated form of data.frame or
a list of results. Default is FALSE}

\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{colData_id}{One of the columns of colData(se). It should be factors of more than one value.}

\item{control}{Base level and one of the factor values of \code{colData(se)[[colData_id]]}}

\item{treatment}{one of the factor values of \code{colData(se)[[colData_id]]}}

\item{...}{other arguments to be passed to functions listed in deFun_list}
}
\value{
a list or data.frame
}
\description{
To identify differentially expressed genes by multiple methods
}
\examples{

se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

# To reduce runtime
se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]

# First define a named list of functions
funs <- list(limma_trend = use_limma_trend, limma_voom = use_limma_voom,
             edgeR_exact = use_edgeR_exact, edgeR_glm = use_edgeR_GLM,
             deseq2 = use_deseq2,
             DELocal = use_DELocal, noiseq = use_NOIseq,
             EBSeq = use_EBSeq)


multi_result <- broadSeq::use_multDE(
    se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"],
    deFun_list = funs, return.df = TRUE,
    colData_id = "stage", control = "Bud", treatment = "Cap",
    rank = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{volcanoPlot}
\alias{volcanoPlot}
\title{Volcano plot with formatted x and y axis label.}
\usage{
volcanoPlot(
  df,
  pValName,
  lFCName,
  sigThreshold = 0.05,
  logFCThreshold = 1,
  labelName = NULL,
  selectedLabel = NULL,
  palette = "nejm"
)
}
\arguments{
\item{df}{a data.frame object}

\item{pValName}{column name of df which provides p-values}

\item{lFCName}{column name of df which provides log fold change values}

\item{sigThreshold}{Threshold for p-values}

\item{logFCThreshold}{Threshold for log fold change values}

\item{labelName}{column name of df to label the dots}

\item{selectedLabel}{which dots to highlight}

\item{palette}{one of "npg" ,"aaas", "lancet", "jco", "ucscgb", "uchicago",
"simpsons" and "nejm" or similar to viridis::cividis(3)}
}
\value{
ggplot object
}
\description{
Volcano plot with formatted x and y axis label.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{use_edgeR_GLM}
\alias{use_edgeR_GLM}
\alias{use_edgeR_exact}
\alias{use_edgeR}
\title{To use SummarizedExperiment with package edgeR}
\usage{
use_edgeR_GLM(se, colData_id, control, treatment, rank = FALSE, ...)

use_edgeR_exact(se, colData_id, control, treatment, rank = FALSE, ...)

use_edgeR(
  se,
  colData_id,
  control,
  treatment,
  rank = FALSE,
  edgeR.n = Inf,
  edgeR.adjust.method = "BH",
  edgeR.sort.by = "PValue",
  option = "GLM",
  ...
)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{colData_id}{One of the columns of colData(se). It should be factors of more than one value.}

\item{control}{Base level and one of the factor values of \code{colData(se)[[colData_id]]}}

\item{treatment}{one of the factor values of \code{colData(se)[[colData_id]]}}

\item{rank}{Logical value default FALSE. If true the result will have an
additional column named "rank"}

\item{...}{other arguments to be passed to edgeR::\code{\link{glmLRT}}
or edgeR::\code{\link{exactTest}}}

\item{edgeR.n}{argument for edgeR::\code{\link{topTags}}}

\item{edgeR.adjust.method}{argument for edgeR::\code{\link{topTags}}}

\item{edgeR.sort.by}{argument for edgeR::\code{\link{topTags}}}

\item{option}{"GLM" or "exact" to indicate to use either edgeR::\code{\link{glmLRT}}
or edgeR::\code{\link{exactTest}}}
}
\value{
a data.frame of output from edgeR::\code{\link{topTags}}
}
\description{
A wrapper function of DESeq2 where input is an object of \code{\link{SummarizedExperiment}}
}
\examples{

se <- readRDS(system.file("extdata",
        "rat_vole_mouseSE_salmon.rds",
        package = "broadSeq"))

# To reduce runtime
se <- se[rowData(se)$chromosome_name == 2,colData(se)$species == "Mouse"]

result <-
    use_edgeR(se = se,
           colData_id = "stage", control = "Bud", treatment = "Cap",
           rank = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrappers.R
\name{use_SAMseq}
\alias{use_SAMseq}
\title{To use SummarizedExperiment with package samr}
\usage{
use_SAMseq(se, colData_id, control, treatment, rank = FALSE, ...)
}
\arguments{
\item{se}{Object of \code{\link{SummarizedExperiment}} class}

\item{colData_id}{One of the columns of colData(se). It should be factors of more than one value.}

\item{control}{Base level and one of the factor values of \code{colData(se)[[colData_id]]}}

\item{treatment}{one of the factor values of \code{colData(se)[[colData_id]]}}

\item{rank}{Logical value default FALSE. If true the result will have an}

\item{...}{other arguments to be passed to samr::SAMseq}
}
\value{
a data.frame object as a result
}
\description{
To use SummarizedExperiment with package samr
}
